/********************************************************************************/
/*Description: ---------------------------------------------------------------- */
/*	include for the Device Status Images Menu ----------------------------------*/
/*                                                                              */
/*       Copyright (C) Siemens-Milltronics Process Instruments Inc.             */
/*       All Rights Reserved.                                                   */
/*                                                                              */
/*       Author: Andreas Fink                                                   */
/********************************************************************************/
/* History----------------------------------------------------------------------*/
/* 	Version 0.2                                                                 */
/*   07-Dec-2007                                                                */
/********************************************************************************/

/*
'Page_Diagnostic_Status' kann in dem Dialog 'Status' anstatt Page_PDM_Diagnostic_Status 
	verwendet werden.

Folgende 4 Macros knnen verwendet werden:
	COOP_IDENTITY_OFF			// Definition von Siemenslogo fr Offline Dialoge
	COOP_IDENTITY_ON			// Definition von Siemenslogo und Status fr Online Dialoge
	POST_READ_ACTIONS_DIAGNOSTIC	// Definition fr die Online Dialoge, wo COOP_IDENTITY_ON verwendet wird
	
	METHOD_PARAMETER_CODE		// Definition von der Methode zum anzeigen und ausblenden von Parameterscode
	LABEL_PARAMETER_NAME(A,B)	// z.B LABEL_PARAMETER_NAME("Parametername", " (Parametercode)")
*/
#ifdef 1

#define COOP_IDENTITY_OFF img_siemens_logo_pdm,
#define COOP_IDENTITY_ON img_siemens_logo_pdm, COLUMNBREAK, img_status_diagnosis_pdm, ROWBREAK,
#define POST_READ_ACTIONS_DIAGNOSTIC POST_READ_ACTIONS { method_Diag_Execute_without_Message }

#define METHOD_PARAMETER_CODE method_parameter_code

#include "Diagnosis.inc"

#else

#define COOP_IDENTITY_OFF
#define COOP_IDENTITY_ON COOP_IDENTITY_OFF
#define POST_READ_ACTIONS_DIAGNOSTIC  

#define METHOD_PARAMETER_CODE local_parameter_code

#endif	// PDM_ENABLE

#define LABEL_PARAMETER_NAME(A,B)	\
	LABEL IF (parameter_code == 1)	\
		{ A + B; }					\
		ELSE						\
		{ A; }

//------------------------------------------------------------------------------
IMAGE img_siemens_logo_pdm
{
	PATH "img_siemens_logo_pdm.gif";
}

IMAGE img_siemens_logo_pdm_hidden
{
	PATH "img_siemens_logo_pdm.gif";
	VALIDITY	FALSE;
}
#ifdef 1
// Includes for online dialogs

IMAGE img_status_diagnosis_pdm
{
	LINK method_PDM_Diag_Execute;
	PATH 
	IF((device_status & 0x08 /* DIA_PV_ANALOG_OUTPUT_FIXED */) && !(device_specific_status_14 & 0x10 /* FAULT_HART_FAILSAFE */))
	{
		"img_mode_simulation_pdm.jpg";
	}
	ELSE{
	IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_TEST)
	{
		IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MAINT_HIGH)
		{
			"img_maint_high_mt_pdm.jpg";
		}
		ELSE
		{
			IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MAINT_MEDIUM)
			{
				"img_maint_medium_mt_pdm.jpg";
			}
			ELSE
			{
				IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MAINT_LOW)
				{
					"img_maint_low_mt_pdm.jpg";
				}
				ELSE
				{
					IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_LOCAL_OVERRIDE)
					{
						"img_mode_local_override_mt_pdm.jpg";
					}
					ELSE
					{
						IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_SIMULATION)
						{
							"img_mode_simulation_mt_pdm.jpg";
						}
						ELSE
						{
							IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_OUT_OF_SERVICE)
							{
								"img_out_of_service_mt_pdm.jpg";
							}
							ELSE
							{
								IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_CONFIG_ERROR)
								{
									"img_config_error_mt_pdm.jpg";
								}
								ELSE
								{
									IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_CONFIG_WARNING)
									{
										"img_config_warning_mt_pdm.jpg";
									}
									ELSE
									{
										IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_CONFIG_CHANGED)
										{
											"img_config_changed_mt_pdm.jpg";
										}
										ELSE
										{
											IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_PROCESS_ALARM)
											{
												"img_process_alarm_mt_pdm.jpg";
											}
											ELSE
											{
												IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_PROCESS_WARNING)
												{
													"img_process_warning_mt_pdm.jpg";
												}
												ELSE
												{
													IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_PROCESS_TOLERANCE)
													{
														"img_process_tolerance_mt_pdm.jpg";
													}
													ELSE
													{
														IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_GOOD)
														{
															"img_good_mt_pdm.jpg";
														}
														ELSE
														{
															IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_TEST)
															{
																"img_mode_test_mt_pdm.jpg";
															}
															ELSE
															{
																"img_blank_mt_pdm.jpg";
															}															
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	ELSE
	{
		IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MAINT_HIGH)
		{
			"img_maint_high_pdm.jpg";
		}
		ELSE
		{
			IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MAINT_MEDIUM)
			{
				"img_maint_medium_pdm.jpg";
			}
			ELSE
			{
				IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MAINT_LOW)
				{
					"img_maint_low_pdm.jpg";
				}
				ELSE
				{
					IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_LOCAL_OVERRIDE)
					{
						"img_mode_local_override_pdm.jpg";
					}
					ELSE
					{
						IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_SIMULATION)
						{
							"img_mode_simulation_pdm.jpg";
						}
						ELSE
						{
							IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_OUT_OF_SERVICE)
							{
								"img_out_of_service_pdm.jpg";
							}
							ELSE
							{
								IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_CONFIG_ERROR)
								{
									"img_config_error_pdm.jpg";
								}
								ELSE
								{
									IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_CONFIG_WARNING)
									{
										"img_config_warning_pdm.jpg";
									}
									ELSE
									{
										IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_CONFIG_CHANGED)
										{
											"img_config_changed_pdm.jpg";
										}
										ELSE
										{
											IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_PROCESS_ALARM)
											{
												"img_process_alarm_pdm.jpg";
											}
											ELSE
											{
												IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_PROCESS_WARNING)
												{
													"img_process_warning_pdm.jpg";
												}
												ELSE
												{
													IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_PROCESS_TOLERANCE)
													{
														"img_process_tolerance_pdm.jpg";
													}
													ELSE
													{
														IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_GOOD)
														{
															"img_good_pdm.jpg";
														}
														ELSE
														{
															IF(PDM_Diag_Status_Diagnosis & PDM_DIAG_MODE_TEST)
															{
																"img_mode_test_pdm.jpg";
															}
															ELSE
															{
																"img_blank_pdm.jpg";
															}	
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
}}

METHOD method_Diag_Execute_without_Message
{
    ACCESS		ONLINE;
    DEFINITION
    {
		_WARNING ("********** UPDATE: Local Status Diagnostic");
		method_PDM_Diag_CheckIdentification();
		
		PDM_Diag_Status_TimeStamp = GetCurrentDateAndTime();
		
		if (PDM_Diag_Status_Communication & PDM_DIAG_COMM_OK)
		{
			std_CheckDeviceStatus();
		}
    }
}
#endif

//------------------------------------------------------------------------------


#ifdef PDM_ENABLE
METHOD method_parameter_code
{
    LABEL IF (local_parameter_code == 1)
			{	"Hide Parameter Code"
				"|fr|Code du Paramtre dsactiver"
				"|sp|Cdigo del Parmetro off"
				"|it|Codice del Parametro disattivato"
				"|de|Parametercode ausblenden"; }
			ELSE
			{	"Show Parameter Code"
				"|fr|Code du Paramtre activr"
				"|sp|Cdigo del Parmetro on"
				"|it|Codice del Parametro attivato"
				"|de|Parametercode einblenden"; }
	ACCESS OFFLINE;
    DEFINITION
    {
        if(local_parameter_code == 1)
        {
            local_parameter_code = 0;
        }
        else
        {
            local_parameter_code = 1;
        }
    }
}
#endif

VARIABLE local_parameter_code
{
    LABEL "";
    CLASS  LOCAL;
    TYPE   UNSIGNED_INTEGER;
    DEFAULT_VALUE   1;
    HANDLING      READ & WRITE;
}

//------------------------------------------------------------------------------
#ifdef 1
MENU Page_Diagnostic_Status
{
	LABEL "Diagnostics" "|de|Diagnose";
	HELP  [menu_diag_status_help];
	STYLE PAGE;
	ITEMS
	{
		COOP_IDENTITY_ON
		PDM_Diag_Status_Communication 				(READ_ONLY),
		PDM_Diag_Status_Diagnosis 					(READ_ONLY),
		PDM_Diag_Status_TimeStamp 					(READ_ONLY),
		PDM_Diag_Rule_Message 						(READ_ONLY),
		method_PDM_Diag_Execute
	}
	POST_READ_ACTIONS_DIAGNOSTIC
}

#endif