/*
$Id: hart/HART_Sensor_Level_Milltronics_LR560/SMHA_LR560_1.ddl 1.105 2010/10/18 20:06:51EDT Wall, Graham (Graham Wall) Dev  $
$ProjectName: d:/elect/source/device_descriptions/pdm/potter_pdm.pj $   $Locker:  $

*/


/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------


         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Resources ------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------
*/

MANUFACTURER 42, DEVICE_TYPE 0x24, DEVICE_REVISION 1, DD_REVISION 1

/* Defines --------------------------------------------------------------------*/
#define EDD_REVISION                     1           //DON'T FORGET TO MATCH THIS ONE WITH THE DD_REVISION ON THE FIRST LINE

#define DD_VERSION                       "01.00.00-32"
#define FIRMWARE_REVISION                "01.00.00-32"
#define DEVICE_MANUAL_FILENAME           "LR560_user_manual_ha_en.pdf|de|LR560_user_manual_ha_de.pdf"
#define DEVICE_ORDER_NUMBER              "7ML5440-xxx00-xAxx"
#define DEVICE_TYPE_ID                   0x24
#define DEVICE_TYPE_NAME                 "SITRANS LR560"
#define DEVICE_TYPE_DESCRIPTION          "HART Echo Field Device SITRANS LR560"
#define DEVICE_TYPE_WEB_SITE             "www.siemens.com/sitranslr560"
#define DEVICE_TYPE_MANUFACTURER         "Siemens AG"
#define DEVICE_TYPE_MANUFACTURER_ID      42
#define COMMON_PRACTICE_COMMAND_REVISION "8.0"
#define COMMUNICATIONS_PROTOCOL          "HART"

#define RANGE_40M                        40.0
#define RANGE_100M                       100.0

/* Range Modes */
#define RANGE_MODE_40M  0
#define RANGE_MODE_100M 1

#define VARIABLE_STATUS_INITIAL 32

#define MAX_FLOAT          999999.0
#define MIN_FLOAT         -999999.0

#define SECONDS_PER_YEAR   31558464 //31536000 - firmware uses 365.26 days per year.
#define SECONDS_PER_DAY     86400
#define SECONDS_PER_HOUR     3600

#define DEVICE_BUSY            32
#define MAX_XMTR_STATUS_LEN     4
#define STATUS_SIZE            16

#define FEET_UNITS         44
#define INCH_UNITS         47
#define METER_UNITS        45
#define CENTIMETER_UNITS   48
#define MILLIMETER_UNITS   49
#define PERCENT_UNITS      57

#define OPT_PHYS_IDENT_NUMBER_MANUFACTURER
#define DEFAULT_MANUFACTURER_ID                  88
#define DEFAULT_VALUE_phys_device_id             "SITRANS LR560"
#define MANUFACTURER_SPECIFIC_phys_factory_reset
#define NO_phys_diagnosis_extension_mask  // We have our own definition for this parameter
#define NO_phys_diagnosis_extension
#define NO_phys_hw_write_protection

/*Transducer options  */

/* Range Hi to Cal Lo coefficients */
#define  RANGE_HI_TO_CAL_LO_FACTOR     (1.0)    // The RANGE_HI is 1 times CAL_LO and
#define  RANGE_HI_TO_CAL_LO_OFFSET     (5.0)    // 5.0m bigger than CAL_LO)

//#define  DEVICE_MAX_SPEC_RANGE_METERS  (100.0)
//#define  DEVICE_MAX_PHYS_RANGE_METERS  (DEVICE_MAX_SPEC_RANGE_METERS + RANGE_HI_TO_CAL_LO_OFFSET)

#define  DEVICE_MIN_CAL_POINT_METERS   0.0
//#define  DEVICE_MAX_CAL_POINT_METERS   DEVICE_MAX_SPEC_RANGE_METERS
#define  DEVICE_MIN_RANGE_METERS       0.0
//#define  DEVICE_MAX_RANGE_METERS       DEVICE_MAX_PHYS_RANGE_METERS

/* Cal Hi for LR560 */
#define  CAL_HI_DEFAULT                 0.0

/* Cal Lo for LR560  */
//#define  CAL_LO_DEFAULT                 100.0

/* Range Lo for LR560 */
#define  RANGE_LO_DEFAULT               0.278    /* (228mm + 50mm for spec + 0 for flange)   */

/* Range Hi for LR560 */
//#define  RANGE_HI_DEFAULT               105.0

#define MACRO_RANGE_LO_DEFAULT          RANGE_LO_DEFAULT
//#define MACRO_RANGE_HI_DEFAULT          RANGE_HI_DEFAULT
//#define MACRO_CAL_LO_DEFAULT            CAL_LO_DEFAULT
#define MACRO_CAL_HI_DEFAULT            CAL_HI_DEFAULT

/* Response Rates */
#define RESPONSE_SLOW   1
#define RESPONSE_MEDIUM 2
#define RESPONSE_FAST   3

#define MACRO_FOLF_TIME_CONSTANT_DEFAULT \
   SELECT (par_tb_response_rate)         \
   {                                     \
      CASE RESPONSE_SLOW:     10.0;      \
      CASE RESPONSE_MEDIUM:   10.0;      \
      CASE RESPONSE_FAST:      0.0;      \
   }

#define MACRO_FILL_RATE_DEFAULT                             \
   SELECT (par_tb_response_rate)                            \
      {                                                     \
      CASE RESPONSE_SLOW   : TO_SENSOR_UNITS_FROM_M(0.1);   \
      CASE RESPONSE_MEDIUM : TO_SENSOR_UNITS_FROM_M(1.0);   \
      CASE RESPONSE_FAST   : TO_SENSOR_UNITS_FROM_M(10.0);  \
      }


/* Default MACRO callback for PAR_PB_MA_FAIL_SAFE parameter */
#define NAMUR_MODE_STD     0
#define NAMUR_MODE_NE43    1
#define MA_FAIL_SAFE_HOLD  3
#define MA_FAIL_SAFE_VALUE 4
#define MACRO_FAIL_SAFE_DEFAULT                    \
   SELECT (par_pb_namur_mode)                      \
    {                                              \
      CASE NAMUR_MODE_STD   : MA_FAIL_SAFE_HOLD;   \
      CASE NAMUR_MODE_NE43  : MA_FAIL_SAFE_VALUE;  \
    }
    
#define MACRO_SENSOR_MAX_RANGE_METERS(offset)    \
   SELECT (par_pb_range_mode_local)              \
   {                                             \
      CASE RANGE_MODE_40M: (RANGE_40M+offset);   \
      DEFAULT:             (RANGE_100M+offset);  \
   }

#define MACRO_SENSOR_MAX_RANGE_UNITS_VALUE(offset)                       \
   SELECT (par_pb_range_mode_local)                                      \
   {                                                                     \
      CASE RANGE_MODE_40M: TO_SENSOR_UNITS_FROM_M((RANGE_40M+offset));   \
      DEFAULT:             TO_SENSOR_UNITS_FROM_M((RANGE_100M+offset));  \
   }

/* Algorithms */
#define ALGORITHM_ALF   1
#define ALGORITHM_A     2
#define ALGORITHM_L     3
#define ALGORITHM_F     4
#define ALGORITHM_AL    5
#define ALGORITHM_AF    6
#define ALGORITHM_LF    7
#define ALGORITHM_bLF   8
#define ALGORITHM_bL    9
#define ALGORITHM_bF    10
#define ALGORITHM_LAST  11
#define ALGORITHM_tF    12

#define  ECHO_POSITION_RISING_EDGE        1
#define  ECHO_POSITION_FALLING_EDGE       2
#define  ECHO_POSITION_CENTER_OF_MASS     3
#define  ECHO_POSITION_HYBRID_COM_LEF     4
#define  ECHO_POSITION_LEADING_EDGE_FIT   5
#define  ECHO_POSITION_HYBRID_TEF_LEF     6
#define  ECHO_POSITION_DEVELOPMENT        7


/* Defines for operation enumeration */
#define OPERATION_APP_OFF        0
#define OPERATION_APP_MATL       1
#define OPERATION_APP_SPACE      2
#define OPERATION_APP_DIST       3

/* Defines for application type enumeration */
#define APPLICATION_STEEL_SILO    1
#define APPLICATION_CONCRETE_SILO 2

#define LINEAL_DISPLAY_FORMAT(units)            \
   SELECT (units)                               \
      {                                         \
      CASE FEET_UNITS:       ".2f"; /* ft */    \
      CASE METER_UNITS:      ".3f"; /* meter */ \
      CASE INCH_UNITS:       ".1f"; /* in */    \
      CASE CENTIMETER_UNITS: ".1f"; /* cm */    \
      CASE MILLIMETER_UNITS: ".f";  /* mm */    \
      CASE PERCENT_UNITS:    ".1f"; /* %  */    \
      DEFAULT:               ".3f";             \
      }

/* Unit conversion macro's */
#define CM_PER_M     ( 100.0 )
#define MM_PER_M     ( 1000.0 )
#define FT_PER_M     ( 1/0.3048 )
#define IN_PER_M     ( 1/0.0254 )

#define TO_SENSOR_UNITS_FROM_M(value)           \
   SELECT (trans1_sensor_unit)                  \
      {                                         \
      CASE 44: value * FT_PER_M;                \
      CASE 45: value;                           \
      CASE 47: value * IN_PER_M;                \
      CASE 48: value * CM_PER_M;                \
      CASE 49: value * MM_PER_M;                \
      }
      //CASE 57: value;                           \
      //CASE 251: value;                          \
      //}

#define TO_FB1_OUT_UNITS_FROM_M(value)          \
   SELECT (func1_AI_out_unit)                   \
      {                                         \
      CASE 44: value * FT_PER_M;                \
      CASE 45: value;                           \
      CASE 47: value * IN_PER_M;                \
      CASE 48: value * CM_PER_M;                \
      CASE 49: value * MM_PER_M;                \
      CASE 57: value;                           \
      CASE 251: value;                          \
      }

#define TO_FB2_OUT_UNITS_FROM_M(value)          \
   SELECT (func2_AI_out_unit)                   \
      {                                         \
      CASE 44: value * FT_PER_M;                \
      CASE 45: value;                           \
      CASE 47: value * IN_PER_M;                \
      CASE 48: value * CM_PER_M;                \
      CASE 49: value * MM_PER_M;                \
      CASE 57: value;                           \
      CASE 251: value;                          \
      }

/* Min, max and defaults */
#define DEFAULT_VALUE_func1_upper_range_value      MACRO_SENSOR_MAX_RANGE_UNITS_VALUE(0.0)
#define DEFAULT_VALUE_func1_lower_range_value        0.0
#define DEFAULT_VALUE_func1_pv_upper_range_value   MACRO_SENSOR_MAX_RANGE_METERS(0.0)
#define DEFAULT_VALUE_func1_pv_lower_range_value     0.0

#define DEFAULT_VALUE_func2_upper_range_value      MACRO_SENSOR_MAX_RANGE_UNITS_VALUE(0.0)
#define DEFAULT_VALUE_func2_lower_range_value        0.0
#define DEFAULT_VALUE_func2_pv_upper_range_value   MACRO_SENSOR_MAX_RANGE_METERS(0.0)
#define DEFAULT_VALUE_func2_pv_lower_range_value     0.0

#define MAX_VALUE_func1_AI_pv_ftime                300.0
#define MIN_VALUE_func1_AI_pv_ftime                  0.0
#define DEFAULT_VALUE_func1_AI_pv_ftime             MACRO_FOLF_TIME_CONSTANT_DEFAULT

#define MAX_VALUE_func2_AI_pv_ftime                300.0
#define MIN_VALUE_func2_AI_pv_ftime                  0.0
#define DEFAULT_VALUE_func2_AI_pv_ftime             MACRO_FOLF_TIME_CONSTANT_DEFAULT

#define MAX_LIMIT MAX_FLOAT
#define MIN_LIMIT MIN_FLOAT
#define MAX_VALUE_func1_AI_hi_hi_lim            TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_hi_hi_lim            TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_hi_hi_lim        TO_FB1_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func1_AI_hi_lim               TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_hi_lim               TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_hi_lim           TO_FB1_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func1_AI_lo_lim               TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_lo_lim               TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_lo_lim           TO_FB1_OUT_UNITS_FROM_M(-999.00)

#define MAX_VALUE_func1_AI_lo_lo_lim            TO_FB1_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func1_AI_lo_lo_lim            TO_FB1_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func1_AI_lo_lo_lim        TO_FB1_OUT_UNITS_FROM_M(-999.00)

#define MAX_VALUE_func2_AI_hi_hi_lim            TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_hi_hi_lim            TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_hi_hi_lim        TO_FB2_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func2_AI_hi_lim               TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_hi_lim               TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_hi_lim           TO_FB2_OUT_UNITS_FROM_M(999.00)

#define MAX_VALUE_func2_AI_lo_lim               TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_lo_lim               TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_lo_lim           TO_FB2_OUT_UNITS_FROM_M(-999.00)

#define MAX_VALUE_func2_AI_lo_lo_lim            TO_FB2_OUT_UNITS_FROM_M(MAX_LIMIT)
#define MIN_VALUE_func2_AI_lo_lo_lim            TO_FB2_OUT_UNITS_FROM_M(MIN_LIMIT)
#define DEFAULT_VALUE_func2_AI_lo_lo_lim        TO_FB2_OUT_UNITS_FROM_M(-999.00)

#define FUNC1_DEFAULT_UNIT                     1342
#define FUNC2_DEFAULT_UNIT                     1342

#define DEFAULT_VALUE_func1_AI_out_unit        1342
#define DEFAULT_VALUE_func2_AI_out_unit        1342

#define FUNC2_AVAILABLE

#define func1_CHANNEL_LIST  {0x10E, [SV1_label]},{ 0x110, [SV2_label]}
#define func2_CHANNEL_LIST  {0x10E, [SV1_label]},{ 0x110, [SV2_label]}

#define FUNC1_UNIT_LIST  {45,[meter],[meters_help] },{ 48,[cm],[centimeters_help]},{49,[mm],[millimeters_help]},{44,[ft],[feet_help]},{47,[in],[inches_help]}
#define FUNC2_UNIT_LIST  {45,[meter],[meters_help] },{ 48,[cm],[centimeters_help]},{49,[mm],[millimeters_help]},{44,[ft],[feet_help]},{47,[in],[inches_help]}

#define DEF_DISPLAY_FORMAT_FUNC1_AI(value)            \
         LINEAL_DISPLAY_FORMAT(func1_AI_out_unit)
         
#define DEF_DISPLAY_FORMAT_FUNC2_AI(value)            \
         LINEAL_DISPLAY_FORMAT(func2_AI_out_unit)

#define STYLE_TABLE   STYLE TABLE;
#define STYLE_PAGE    STYLE PAGE;
#define STYLE_GROUP   STYLE GROUP;
#define STYLE_DIALOG  STYLE DIALOG;
#define STYLE_WINDOW  STYLE WINDOW;
#define STYLE_MENU    STYLE MENU;

#define FUNC1_TITLE [func1_AI]
#define FUNC2_TITLE [func2_AI]

/* Device type Checking -  these are used by "SIHAST.inc" to control device checking */
#define ENABLE_IDENTCHECK
#define ENABLE_DIAGNOSIS

/* EDD */
#include "SI_INCLUDES.inc"                 /* Diagnostic Icons */

/* enable save feature in echo profile window */
#define SAVEECHOPROFILE_INC
//#define SHOWTREND_INC

/* removed from readechoprofile causes silently ignored compile errors in that file */
#define NUMBER_ECHO_POINTS             512
#define NUMBER_TVT_POINTS              128
#define ECHO_DECIMATION_FACTOR           8
#define TVT_DECIMATION_FACTOR            2
#define NUMBER_ECHO_POINTS_STD          64
#define NUMBER_TVT_POINTS_STD           64
// PDM can't handle anything mor than a simple macro for NUMBER_OF_ELEMENTS so the following defines have been added
#define NUMBER_ECHO_POINTS_STD_PLUS_ONE 65
#define NUMBER_TVT_POINTS_STD_PLUS_ONE  65

/* Include Files --------------------------------------------------------------*/
/***** Standard includes *****/
//#include "bi_codes.h"                      /* Standard EDDL Return Codes */
#include "macros.h"                        /* Standard EDDL Macro's */
#include "methods.h"                       /* Standard EDDL Methods's */

/***** PDM Standard includes *****/
#include "SIHA.inc"                        /* Standard Hart Includes */
#include "SI_MainMenu.inc"                 /* Standard Menu includes */
#include "SI_FileM.inc"                    /* Standard File Menu */
#include "SI_ViewM.inc"                    /* Standard View Menu */
#include "SI_OptM.inc"                     /* Standard Options Menu */
#include "SI_HlpM.inc"                     /* Standard Help Menu */

/* ##### Use the following line for IdentCheck METHODs using tag ##### */
//#include "SIHAST.inc"                    /* Standard Device type Checking */
/* ##### Use the following 2 lines for IdentCheck METHODs using longTag ##### */
#include "SIHASTIdent02_replacement.inc"   /* Standard Device type Checking */
#include "SIHASTDIAG_02.inc"

#include "SI__Global_02.ddl"               /* Diagnostic support */

/***** Product Specific Includes *****/
#include "pvdef.dd"
#include "compatability.inc"

/* Devices sub menu */
#include "selftest.dd"                     /* Self Test menu item in Device sub menu */
#include "reset.dd"                        /* Master Reset menu item in Device sub menu */
// #include "simulate_faults.dd"              /* Fault Simulation menu item in Device sub menu */
#include "writelock.dd"                    /* Write lock menu item in Device sub menu */
#include "simulation.dd"                   /* Simulation menu item in Device sub menu */
#include "maintenance.dd"                  /* Maintenance dialogs in Device and View|Status */
#include "quickstart.dd"                   /* Quick setup wizard menu item in Device sub menu */

/* View sub menu */
#include "display.dd"                      /* Display window in View sub menu */
#include "im_functions.dd"
#include "trend.inc"
#include "echoprocessing.inc"              /* Echo profile tabbed dialog */

/* Imports --------------------------------------------------------------------*/
#include "LR560_HA_imports.dd"

#include "diagnostic.dd"                   /* Status window item in View sub menu */
#include "wear.dd"                         /* Wear window item in View sub menu */

/* Maintenance and Diagnostic information */
#include "SMHA_LR560_DeviceDiagnosis.dd"   /* Extended diagnostic information */

/* Collections ----------------------------------------------------------------*/

/* Relations ------------------------------------------------------------------*/
#include "LR560_HA_relations.dd"

/* Variable Definitions -------------------------------------------------------*/
#include "LR560_HA_parameters.dd"          /* Auto generated parameters */

/*-----------------------------------------------------------------------------
   Description:: Information for EDD_HelpGen
   Created by: Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE phys_device_description_local
{
   LABEL [phys_device_description_local_label];
   HELP [phys_device_description_local_help];
   CLASS LOCAL;
   TYPE ASCII(12)
   {
      DEFAULT_VALUE DD_VERSION;
   }
   PRE_EDIT_ACTIONS
   {
      method_preedit_dd_rev
   }
}

/*-----------------------------------------------------------------------------
   Description:
            manufacturer_id_local,
            device_id               (DISPLAY_VALUE),
            device_type_local,
            transmitter_revision,
            local_edd_revision,
            universal_revision,
            protocol_local,
            polling_address            (READ_ONLY),
            local_cmn_revision

   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE manufacturer_id_local
{
   LABEL [manufacturer_id_local_label];
   HELP  [manufacturer_id_code_help];
   CLASS LOCAL;
   TYPE  UNSIGNED_INTEGER(1);
   DEFAULT_VALUE DEVICE_TYPE_MANUFACTURER_ID;
   HANDLING READ;
   PRE_EDIT_ACTIONS
   {
      DEFINITION
      {
         manufacturer_id_local.VARIABLE_STATUS = 0;
      }
   }
}

VARIABLE device_type_local
{
   LABEL [device_type_local_label];
   HELP  [manufacturers_device_type_help];
   CLASS LOCAL;
   TYPE  UNSIGNED_INTEGER(1);
   DEFAULT_VALUE DEVICE_TYPE_ID;
   HANDLING READ;
   PRE_EDIT_ACTIONS
   {
      DEFINITION
      {
         device_type_local.VARIABLE_STATUS = 0;
      }
   }
}

VARIABLE local_cmn_revision
{
   LABEL [local_cmn_revision_label];
   HELP  [local_cmn_revision_help];
   CLASS LOCAL;
   TYPE  ASCII(5);
   DEFAULT_VALUE COMMON_PRACTICE_COMMAND_REVISION;
   HANDLING READ;
   PRE_EDIT_ACTIONS
   {
      DEFINITION
      {
         local_cmn_revision.VARIABLE_STATUS = 0;
      }
   }
}

VARIABLE local_edd_revision
{
    LABEL "EDD Revision";
    HELP  [local_edd_revision_help];    
    CLASS  LOCAL;
    TYPE   UNSIGNED_INTEGER(1);
    DEFAULT_VALUE   EDD_REVISION;
    HANDLING      READ;
   PRE_EDIT_ACTIONS
   {
      DEFINITION
      {
         local_edd_revision.VARIABLE_STATUS = 0;
      }
   }
}

VARIABLE protocol_local
{
   LABEL [protocol_local_label];
   HELP  [protocol_local_help];
   CLASS LOCAL;
   TYPE  ASCII(5);
   DEFAULT_VALUE COMMUNICATIONS_PROTOCOL;
   HANDLING READ;
   PRE_EDIT_ACTIONS
   {
      DEFINITION
      {
         protocol_local.VARIABLE_STATUS = 0;
      }
   }
}

/*-----------------------------------------------------------------------------
   Description: Information for EDD_HelpGen
   Created by:  Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE DEVICE_TYPE_Name
{
   LABEL "DEVICE_TYPE_Name";
   CLASS LOCAL;
   TYPE ASCII(40)
   {
      DEFAULT_VALUE DEVICE_TYPE_NAME;
   }
}

VARIABLE DEVICE_TYPE_Description
{
   LABEL "DEVICE_TYPE_Description";
   CLASS LOCAL;
   TYPE ASCII(256)
   {
      DEFAULT_VALUE DEVICE_TYPE_DESCRIPTION;
   }
}

VARIABLE DEVICE_TYPE_Manufacturer
{
   LABEL "DEVICE_TYPE Manufacturer";
   CLASS LOCAL;
   TYPE ASCII(40)
   {
      DEFAULT_VALUE DEVICE_TYPE_MANUFACTURER;
   }
}

VARIABLE DEVICE_TYPE_ContactWebsite
{
   LABEL "DEVICE_TYPE Website";
   CLASS LOCAL;
   TYPE ASCII(40)
   {
      DEFAULT_VALUE DEVICE_TYPE_WEB_SITE;
   }
}

VARIABLE DEVICE_Order_Number
{
   LABEL [DEVICE_Order_Number_label];
   HELP  [DEVICE_Order_Number_help];
   CLASS LOCAL;
   TYPE    ASCII (32)
   {
      DEFAULT_VALUE DEVICE_ORDER_NUMBER;
   }
   HANDLING    READ;
   PURPOSE      "Device.Type.Ident.OrderNumber";
}

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE phys_device_certification
{
   LABEL    [phys_device_certification_label];
   HELP     [phys_device_certification_help];
   CLASS    LOCAL;
   TYPE ENUMERATED (1) 
   {
      DEFAULT_VALUE 0;
      { 0, "see plate|de|siehe Geraeteschild" }
   }
   HANDLING READ;
   PRE_EDIT_ACTIONS
   {
      DEFINITION
      {
         phys_device_certification.VARIABLE_STATUS = 0;
      }
   }
}

VARIABLE phys_write_locking
{
   LABEL [ phys_write_locking_label ];
   HELP [ phys_write_locking_help ];
   CLASS DEVICE;
   TYPE     ENUMERATED(2)
   {
      { 2457, [off] },
      { 0,    [on]  }
   }
   DEFAULT_VALUE 2457;
   HANDLING READ & WRITE;
   POST_READ_ACTIONS
   {
      DEFINITION
      {
         if ( (phys_write_locking != 0) && (phys_write_locking != 2457) )
            phys_write_locking = 0;
      }
   }
}

VARIABLE remove_dependencies
{
   LABEL "";
   HELP "";
   CLASS DEVICE;
   TYPE INTEGER;
   HANDLING WRITE;
}

VARIABLE add_dependencies
{
   LABEL "";
   HELP "";
   CLASS DEVICE;
   TYPE INTEGER;
   HANDLING WRITE;
}

VARIABLE par_pb_range_mode_local
{
   LABEL [ par_pb_range_mode_label ];
   HELP [ par_pb_range_mode_help ];
   CLASS LOCAL;
   TYPE ENUMERATED (1) 
   {
      DEFAULT_VALUE 1;
      { 0, [range40MConfigured_label] },
      { 1, [range100MConfigured_label] }
   }
   HANDLING READ & WRITE;
   POST_EDIT_ACTIONS
   {
      DEFINITION
      {
         method_update_range_mode_defaults();
               
         /* Set variable status to valid, i.e. not changed so that
            PDM does not raise the dialog to save changes (on-line).
            This is valid since range_mode is not downloaded. */
         par_pb_range_mode_local.VARIABLE_STATUS = 0;
      }
   }  
}


VARIABLE ret_CheckDeviceRangeMode
{
   LABEL  "ret_CheckDeviceIdentification";
   CLASS  LOCAL;
   TYPE   UNSIGNED_INTEGER (1)
   {
      DEFAULT_VALUE  ID_CHECK_ABORT;
   }
   HANDLING READ;
}

VARIABLE var_range_mode_configured
{
   LABEL  "var_range_mode_configured";
   CLASS  LOCAL;
   TYPE   UNSIGNED_INTEGER(1)
   {
      DEFAULT_VALUE  0;
   }
}

VARIABLE var_range_mode_match
{
   CLASS  LOCAL;
   TYPE   UNSIGNED_INTEGER(1)
   {
      DEFAULT_VALUE  0;
   }
}

VARIABLE par_pb_units 
{
   LABEL [par_pb_units_label];
   HELP [par_pb_units_help];
   CLASS DEVICE;
   TYPE ENUMERATED (1) 
   {
      DEFAULT_VALUE 45;
      { 44, [ft_label] },
      { 45, [meter_label] },
      { 47, [in_label] },
      { 48, [cm_label] },
      { 49, [mm_label] },
      { 57, [Percent] }
   }
   HANDLING READ & WRITE;
   PRE_EDIT_ACTIONS
   {
      method_preedit_par_pb_units
   }

   POST_EDIT_ACTIONS
   {
      method_postedit_par_pb_units
   }
}

/* Command Definitions --------------------------------------------------------*/
#include "LR560_HA_commands.dd"            /* Auto generated commands */
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
COMMAND read_pb_lock
{
   NUMBER 218;
   OPERATION READ;
   TRANSACTION
   {
      REQUEST
      {
      }
      REPLY
      {
         response_code,device_status,
         phys_write_locking
      }
   }
   RESPONSE_CODES
   {
      0, SUCCESS,            [no_command_specific_errors];
      2, DATA_ENTRY_ERROR,   [invalid_selection];
      3, DATA_ENTRY_ERROR,   [passed_parameter_too_large];
      4, DATA_ENTRY_ERROR,   [passed_parameter_too_small];
      5, MISC_ERROR,         [too_few_data_bytes_recieved];
      6, MISC_ERROR,         [xmtr_specific_command_error];
      7, MODE_ERROR,         [in_write_protect_mode];
      8, DATA_ENTRY_WARNING, [set_to_nearest_possible_value];
      16,MODE_ERROR,         [access_restricted];
   }
}

COMMAND write_pb_lock
{
   NUMBER 219;
   OPERATION WRITE;
   TRANSACTION
   {
      REQUEST
      {
         phys_write_locking
      }
      REPLY
      {
         response_code,device_status,
         phys_write_locking
      }
   }
   RESPONSE_CODES
   {
      0, SUCCESS,            [no_command_specific_errors];
      2, DATA_ENTRY_ERROR,   [invalid_selection];
      3, DATA_ENTRY_ERROR,   [passed_parameter_too_large];
      4, DATA_ENTRY_ERROR,   [passed_parameter_too_small];
      5, MISC_ERROR,         [too_few_data_bytes_recieved];
      6, MISC_ERROR,         [xmtr_specific_command_error];
      7, MODE_ERROR,         [in_write_protect_mode];
      8, DATA_ENTRY_WARNING, [set_to_nearest_possible_value];
      16,MODE_ERROR,         [access_restricted];
   }
}

COMMAND write_remove_dependencies
{
   NUMBER 251;
   OPERATION WRITE;
   TRANSACTION
   {
      REQUEST
      {
         remove_dependencies
      }
      REPLY
      {
         response_code,device_status,remove_dependencies
      }
   }
   RESPONSE_CODES
   {
      0, SUCCESS,            [no_command_specific_errors];
      2, DATA_ENTRY_ERROR,   [invalid_selection];
      3, DATA_ENTRY_ERROR,   [passed_parameter_too_large];
      4, DATA_ENTRY_ERROR,   [passed_parameter_too_small];
      5, MISC_ERROR,         [too_few_data_bytes_recieved];
      6, MISC_ERROR,         [xmtr_specific_command_error];
      7, MODE_ERROR,         [in_write_protect_mode];
      8, DATA_ENTRY_WARNING, [set_to_nearest_possible_value];
      16,MODE_ERROR,         [access_restricted];
   }
}

COMMAND write_add_dependencies
{
   NUMBER 251;
   OPERATION WRITE;
   TRANSACTION
   {
      REQUEST
      {
         add_dependencies
      }
      REPLY
      {
         response_code,device_status,add_dependencies
      }
   }
   RESPONSE_CODES
   {
      0, SUCCESS,            [no_command_specific_errors];
      2, DATA_ENTRY_ERROR,   [invalid_selection];
      3, DATA_ENTRY_ERROR,   [passed_parameter_too_large];
      4, DATA_ENTRY_ERROR,   [passed_parameter_too_small];
      5, MISC_ERROR,         [too_few_data_bytes_recieved];
      6, MISC_ERROR,         [xmtr_specific_command_error];
      7, MODE_ERROR,         [in_write_protect_mode];
      8, DATA_ENTRY_WARNING, [set_to_nearest_possible_value];
      16,MODE_ERROR,         [access_restricted];
   }
}

/* Menu Definitions -----------------------------------------------------------*/
#include "LR560_HA_menus.dd"               /* Auto generated menu structure */

/*-----------------------------------------------------------------------------
   Description: MENU Bar
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_Main_Specialist
{
   LABEL  [main_menu];
   STYLE_MENU
   ITEMS
   {
      Menu_File,        /* use standard PDM method */
      Menu_S_Device,
      Menu_S_View,
      Menu_S_Options,   /* use standard PDM method */
      Menu_Help         /* use standard PDM method */
   }
}

MENU Menu_Main_Maintenance
{
   LABEL  [main_menu];
   STYLE_MENU
   ITEMS
   {
      Menu_File,        /* use standard PDM method */
      Menu_M_Device,
      Menu_M_View,      /* use standard PDM method */
      Menu_M_Options,   /* use standard PDM method */
      Menu_Help         /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: Main table
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifndef PDM_ENABLE
MENU offline_root_menu
{
    LABEL DEVICE_TYPE_NAME;
    ITEMS
    {
      Tab_s_ident,
      Tab_configure_menu,
      Tab_diagnostics,
      Tab_commns_menu,
      Tab_security_menu
      /* Tab_characteristics */
    }
}
#endif

/* Main table for specialist is generated */

MENU Table_Main_Maintenance
{
   LABEL  [Table_Main_Specialist_label];
   ITEMS
   {
      Tab_s_ident,
      Tab_configure_menu,
      Tab_diagnostics,
      Tab_commns_menu
      /* Tab_characteristics */
   }
}

/*-----------------------------------------------------------------------------
   Description: Device drop down menu
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
#ifndef PDM_ENABLE  /* Only use root menus for non-PDM DD (DTM) */
MENU device_root_menu
{
   LABEL  [menu_Device];
   ITEMS
   {
      std_CommWay,                 /* use standard PDM method */
      SEPARATOR,
      std_LoadinDevice,            /* use standard PDM method */
      std_LoadinPC,                /* use standard PDM method */
      SEPARATOR,
      method_quicksetup_wizard,
      SEPARATOR,
      OfflineDialog_profile_and_tvt,
      OfflineDialog_Maintenance_Status,
      OnlineWindow_wear,
      SEPARATOR,
      method_pv_exchange_select,
      method_menu_self_test,
      transmitter_loop_test,       /* use standard PDM method */
      SEPARATOR,
      configuration_flag_reset,    /* use standard PDM method */
      method_phys_factory_reset_factory_defaults,
      SEPARATOR,
      OnlineDialog_hart_comm,      /* use standard PDM method */
   }
}
#endif

MENU Menu_S_Device
{
   LABEL    [menu_Device];
   STYLE_MENU
   ITEMS
   {
      std_CommWay,                    /* use standard PDM method */
      SEPARATOR,
      std_LoadinDevice,               /* use standard PDM method */
      std_LoadinPC,                   /* use standard PDM method */
      SEPARATOR,
      method_quicksetup_wizard,
      SEPARATOR,
      method_menu_profile_and_tvt,
      OfflineDialog_Maintenance_Status,
      OnlineWindow_wear,
      SEPARATOR,
      method_pv_exchange_select,
      method_menu_self_test,
      transmitter_loop_test,          /* use standard PDM method */
      SEPARATOR,
      configuration_flag_reset,       /* use standard PDM method */
      method_phys_factory_reset_factory_defaults,
      SEPARATOR,
      OnlineDialog_hart_comm          /* use standard PDM method */
   }
}

MENU Menu_M_Device
{
   LABEL  [menu_Device];
   STYLE_MENU
   ITEMS
   {
      std_CommWay,                    /* use standard PDM method */
      SEPARATOR,
      std_LoadinDevice,               /* use standard PDM method */
      std_LoadinPC,                   /* use standard PDM method */
      SEPARATOR,
      method_quicksetup_wizard,
      SEPARATOR,
      method_menu_profile_and_tvt,
      OfflineDialog_Maintenance_Status,
      OnlineWindow_wear,
      SEPARATOR,
      method_pv_exchange_select,
      method_menu_self_test,
      transmitter_loop_test,          /* use standard PDM method */
      SEPARATOR,
      configuration_flag_reset,       /* use standard PDM method */
      method_phys_factory_reset_factory_defaults,
      SEPARATOR,
      /*OnlineDialog_write_locking,*/
      OnlineDialog_hart_comm          /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: View drop down menu
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Menu_S_View
{
   LABEL  [menu_View];
   STYLE_MENU
   ITEMS
   {
      OnlineWindow_display,
      diagnostic_menu,
      SEPARATOR,
      std_Funktionsleiste,       /* use standard PDM method */
      std_Statuszeile,           /* use standard PDM method */
      SEPARATOR,
      std_Update                 /* use standard PDM method */
   }
}

MENU Menu_M_View
{
   LABEL  [menu_View];
   STYLE_MENU
   ITEMS
   {
      OnlineWindow_display,
      diagnostic_menu,
      SEPARATOR,
      std_Funktionsleiste,       /* use standard PDM method */
      std_Statuszeile,           /* use standard PDM method */
      SEPARATOR,
      std_Update                 /* use standard PDM method */
   }
}

/*-----------------------------------------------------------------------------
   Description: upload/download
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU download_variables
{
   LABEL [menu_load_to_PC];
   ITEMS
   {
      longTag,
      tag,
      descriptor,
      message,
      date,
      config_change_counter,
      //var_collection_serial_number,
      par_pb_units,
      trans1_sensor_unit,
      trans1_cal_point_lo,
      trans1_cal_point_hi,
      phys_write_locking,
      DOWNLOADLIST
   }
   PRE_READ_ACTIONS
   {
      method_download_variables_pre_read_actions
   }
   POST_READ_ACTIONS
   {
      method_download_variables_post_read_actions
   }
}

MENU upload_variables
{
   LABEL  [menu_load_to_device];
   ITEMS
   {
      IF (var_range_mode_match == 1)
      {
         longTag,
         tag,
         descriptor,
         message,
         date,
         /* The following 9 parameters must be here at the beginning and in the order specified. */
         trans1_sensor_unit,
         par_pb_units,
         trans1_cal_point_lo,
         trans1_cal_point_hi,
         par_pb_operation,
         par_pb_ma_function,
         par_pb_ma_20_setpoint,
         par_pb_ma_0_4_setpoint,
         func1_AI_out_value,
         UPLOADLIST,
      }
   }

   PRE_WRITE_ACTIONS
   {
      method_check_range_mode_match,
      // Check for "var_range_mode_match == 1" moved into method below
      // This was necessary to get PDM to call function below!
      method_upload_variables_pre_write_actions
   }

   POST_WRITE_ACTIONS
   {
      IF (var_range_mode_match == 1)
      {
         method_upload_variables_post_write_actions
      }
   }
}

/*-----------------------------------------------------------------------------
   Description: Range mode selection
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU dialog_range_mode
{
   LABEL  [ par_pb_range_mode_label ];
   HELP   [ par_pb_range_mode_help ];
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      par_pb_range_mode_local,
      method_read_range_mode
   }
}

/* Graphic Elements -----------------------------------------------------------*/

/* Method Definitions ---------------------------------------------------------*/
#include "LR560_HA_methods.dd"             /* methods called from autogenerated files */

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_download_variables_pre_read_actions
{
   DEFINITION
   {
      _TRACE("Start Download");
      ReadCommand(read_trans1_sensor_unit);
      ReadCommand(read_func1_AI_out_unit_text);
      ReadCommand(read_func2_AI_out_unit_text);
      par_pb_units = func1_AI_out_unit; // In Hart these should match. This is done in case the following command does not work
      ReadCommand(read_pv);
   }
}

METHOD method_download_variables_post_read_actions
{
   DEFINITION
   {
      /* the default values may be out of range, so update them */
      //local_trans1_cal_point_hi = trans1_cal_point_hi;
      //local_trans1_cal_point_lo = trans1_cal_point_lo;
      _TRACE("Finish Download");
   }
}

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_upload_variables_pre_write_actions
{
   DEFINITION
   {
      if (var_range_mode_match == 1)
      {
         _TRACE("Start Upload to Device");

         /* Write this first if the user has decided to unlock the device */
         if ( phys_write_locking == 2457)
         {
            WriteCommand(write_pb_lock);
            phys_write_locking.VARIABLE_STATUS = 0;
         }

         remove_dependencies = 1 ;
         WriteCommand(write_remove_dependencies);

         send_command(2); // This will  get the current value of PV.DAQ.ANALOG_VALUE
         DELAY_TIME(1);
         send_command(40); // This will set PV.DAQ.ANALOG_VALUE to a fixed current of PV.DAQ.ANALOG_VALUE
      }
   }
}

METHOD method_upload_variables_post_write_actions
{
   DEFINITION
   {
      PV.DAQ.ANALOG_VALUE = 0.0;
      DELAY_TIME(1);
      send_command(40);  // This will take us out of fixed current mode

      add_dependencies = 0 ;
      WriteCommand(write_add_dependencies);

      /* Write this last if the user has decided to lock the device */
      if ( phys_write_locking != 2457)
      {
         WriteCommand(write_pb_lock);
         phys_write_locking.VARIABLE_STATUS = 0;
      }
      _TRACE("Finish Upload to device");
   }
}

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_read_range_mode
{
   LABEL  [ read_range_mode_from_device_label ];
   HELP   [ read_range_mode_from_device_help ];
   DEFINITION
   {
      ReadCommand(read_pb_mode);
   }
}

/*-----------------------------------------------------------------------------
   Description: POST_EDIT_ACTIONS for VARIABLE par_pb_range_mode_local.
                The method resets parameters which are dependant of range mode
                to their default value when range mode has been changed.
   Created by: Joffrey Carlier
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_update_range_mode_defaults
{
   trans1_cal_point_lo       = trans1_cal_point_lo.DEFAULT_VALUE;
   //local_trans1_cal_point_lo = local_trans1_cal_point_lo.DEFAULT_VALUE;
   par_pb_ma_20_setpoint     = par_pb_ma_20_setpoint.DEFAULT_VALUE;
   par_tb_range_hi           = par_tb_range_hi.DEFAULT_VALUE;
}

/*-----------------------------------------------------------------------------
   Description: The method sets the status of parameters affected by range mode
                to "initial", i.e. unchanged.
   Created by: Joffrey Carlier
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_set_params_status_initial
{
   trans1_cal_point_lo.VARIABLE_STATUS       = VARIABLE_STATUS_INITIAL;
   //local_trans1_cal_point_lo.VARIABLE_STATUS = VARIABLE_STATUS_INITIAL;
   par_pb_ma_20_setpoint.VARIABLE_STATUS     = VARIABLE_STATUS_INITIAL;
   par_tb_range_hi.VARIABLE_STATUS           = VARIABLE_STATUS_INITIAL;
}

/*-----------------------------------------------------------------------------
   Description: PRE_WRITE_ACTIONS for Menu upload_variables
   Created by: Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_check_range_mode_match
{
   int rangeMode;
   
   rangeMode = par_pb_range_mode_local;

   ReadCommand(read_pb_mode);
   
   if (rangeMode != par_pb_range_mode)
   {
      var_range_mode_match = 0;
      
      /* Restore local range mode (since it was changed when reading device range mode)
         to keep the table consistent */
      par_pb_range_mode_local = rangeMode;
      
      PUT_MESSAGE([range_mode_mismatch_message_label]);
   }
   else
   {
      var_range_mode_match = 1;
   }
}

/*-----------------------------------------------------------------------------
   Description: PRE_EDIT_ACTIONS for VARIABLE phys_device_description_local
   Created by: Included in template
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_preedit_dd_rev
{
   DEFINITION
   {
      phys_device_description_local = DD_VERSION;
      phys_device_description_local.VARIABLE_STATUS = 0;
   }
}

/*-----------------------------------------------------------------------------
   Description: PRE_EDIT_ACTIONS for VARIABLE "tag"
   Created by: Joffrey Carlier
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_preedit_tag
{
   DEFINITION
   {
      long  select;
      
      if (var_range_mode_configured == 0)
      {
         /* Request user to select range mode */
         MenuDisplay(dialog_range_mode,dictionary_string(ok_button_label), select);

         /* Force PDM to update default values of affected parameters (fails to do it!) */
         method_update_range_mode_defaults();
        
         /* range mode dialog shall only be called once */
         var_range_mode_configured = 1;
        
         /* Set variable status to valid, i.e. not changed so that
            PDM does not raise the dialog to save changes (on-line).
            This is valid since range_mode is not downloaded. */
         par_pb_range_mode_local.VARIABLE_STATUS = 0;
        
         /* Set status of parameters affected by range mode to "Initial" */
         method_set_params_status_initial();
      }
   }
}

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_set
{
   LABEL [transfer];
   HELP  [transfer_help];
   DEFINITION
   {
   }
}

/*-----------------------------------------------------------------------------
   Description    Transfer button from echo setup window
   Created by:    Joffrey Carlier
   Revised by:    
 ------------------------------------------------------------------------------*/
METHOD method_echo_setup_transfer
{
   LABEL [transfer_to_device_button_label];
   HELP  [transfer_to_device_button_help];
   DEFINITION
   {
      WriteCommand(write_tb_quick_setup1);
      WriteCommand(write_tb_shaping);
      WriteCommand(write_tb_confidence);
      WriteCommand(write_pb_ma_limits);
      WriteCommand(write_tb_rate);
   }
}

/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_pv_exchange_select
{
   LABEL [method_pv_exchange_select_no_volume_label];
   HELP  [method_pv_exchange_select_no_volume_help];
   DEFINITION
   {
      char status[STATUS_SIZE];
      int choice;

      send(158, status);
      if ( status[STATUS_RESPONSE_CODE] )
      {
         display_response_status(158, status[STATUS_RESPONSE_CODE]);
         process_abort();
      }

      switch (ivar_value(par_pb_ma_function))
      {
         case 1:
            ACKNOWLEDGE([ao_set_to_level_label]);
            break;
         case 2:
            ACKNOWLEDGE([ao_set_to_space_label]);
            break;
         case 3:
            ACKNOWLEDGE([ao_set_to_distance_label]);
            break;
      }

      choice = SELECT_FROM_LIST([select_new_ao_label],[ao_selections_without_volume_label]);

      iassign(par_pb_ma_function, choice + 1);

      send(159, status);
      if ( status[STATUS_RESPONSE_CODE] )
      {
         display_response_status(159, status[STATUS_RESPONSE_CODE]);
         process_abort();
      }

      switch (ivar_value(par_pb_ma_function))
      {
         case 1:
            ACKNOWLEDGE([ao_set_to_level_label]);
            break;
         case 2:
            ACKNOWLEDGE([ao_set_to_space_label]);
            break;
         case 3:
            ACKNOWLEDGE([ao_set_to_distance_label]);
            break;
      }
   }
}
/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/

























































