 /*
$Id: hart/HART_Sensor_Level_Milltronics_LR560/autotvt.inc 1.7 2010/07/16 07:54:29EDT Thomas Welsh (Thomas Welsh) Dev  $
$ProjectName: d:/elect/source/device_descriptions/pdm/potter_pdm.pj $   $Locker:  $
*/
#ifndef AUTO_TVT_DD
#define AUTO_TVT_DD
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
		 Auto TVT dialog for a device that uses auto false echo suppression feature.
       
         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

       The user calls the method "method_menu_auto_false_echo_suppression" or this
       method can be added to a menu.
       
       The "autotvtopt.dd" file must be created, 
       Use the template with the name "autotvtopt.tpl.dd".
       
   Defines --------------------------------------------------------------------*/
#define AUTO_TVT_OFF   0
#define AUTO_TVT_ON    1
#define AUTO_TVT_LEARN 2

#define AUTO_TVT_LEARN_DELAY     15

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
var_backup_auto_tvt_mode     LIKE VARIABLE AUTO_TVT_MODE  {}
var_backup_auto_tvt_range    LIKE VARIABLE AUTO_TVT_RANGE {}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Page_auto_false_echo_suppression
{
   LABEL [method_menu_auto_tvt_label];
   HELP  [method_menu_auto_tvt_help];
   STYLE_PAGE
   ITEMS
   {
      COOP_IDENTITY_ON
      AUTO_TVT_MODE,
      AUTO_TVT_RANGE,
      method_auto_near_tvt_learn,
      method_auto_near_tvt_transfer
   }
}

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Make a backup copy of the data we are modifying so it can be
                restored if needed
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_backup_auto_near_tvt_shaper
{
   DEFINITION
   {
      var_backup_auto_tvt_mode  = AUTO_TVT_MODE;
      var_backup_auto_tvt_range = AUTO_TVT_RANGE;

      method_auto_near_tvt_init();
   }
}

/*-----------------------------------------------------------------------------
   Description: Restore the data we are modifying from the backup copy
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_restore_auto_near_tvt_shaper
{
   DEFINITION
   {
      AUTO_TVT_MODE  = var_backup_auto_tvt_mode;
      AUTO_TVT_RANGE = var_backup_auto_tvt_range;
      var_backup_auto_tvt_range = 0.0; // prevent range warnings when units are changed
   }
}
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_auto_near_tvt_learn
{
   LABEL [learn_button_label];
   HELP  [learn_button_help];
   DEFINITION
   {
      int result;

      result = SELECT_FROM_LIST("This will learn a new TVT, once done it can not be undone."
                                "|de|Eine neue TVT-Kurve wird ermittelt; kann nicht rckgngig gemacht werden."
                                "|fr|Obtention d'une nouvelle courbe TVT (procdure irrversible)."
                                "|es|Se obtiene una curva TVT nueva (no es posible la anulacin)", dictionary_string(confirm_buttons_label));
      if (result)
      {
         return;
      }
      AUTO_TVT_MODE = AUTO_TVT_LEARN;
      AUTO_TVT_WRITE_COMMAND;
      do
      {
         DELAY(AUTO_TVT_LEARN_DELAY,"Auto TVT Learn in progress..." 
                                    "|de|Autom. TVT im Ablauf..."
                                    "|fr|Obtention TVT Auto en cours..."
                                    "|es|Obtencin TVT auto pendiente...");
         // read it back to make sure it got set properly
         AUTO_TVT_READ_COMMAND;
      } while (AUTO_TVT_MODE == AUTO_TVT_LEARN);
   }
}

METHOD method_auto_near_tvt_transfer
{
   LABEL [transfer_to_device_button_label];
   HELP  [transfer_to_device_button_help];
   DEFINITION
   {
      AUTO_TVT_WRITE_COMMAND;
      // read it back to make sure it got set properly
      AUTO_TVT_READ_COMMAND;
   }
}

METHOD method_auto_near_tvt_init
{
   DEFINITION
   {
      AUTO_TVT_RANGE_UNITS_READ_COMMAND;
      AUTO_TVT_READ_COMMAND;
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
