 /*
$Id: hart/HART_Sensor_Level_Milltronics_LR560/compatability.inc 1.3 2009/08/07 10:12:35EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/pdm/potter_pdm.pj $   $Locker:  $
*/

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
		 Library DD File.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

   Defines --------------------------------------------------------------------*/

/* Standard include files */
#include "bi_codes.h"
#include "macros.h"  // This file will be replaced for DTM generation

#ifndef DTM_ENABLE
   #define PDM_ENABLE _PDM_
#endif

// Macro's to use until these builtin's are supported
#ifdef PDM_ENABLE

   #if _PDM_ < 700   // this is planned to be added to PDM version 7
      // string functions
      #define strequal(s1, s2) (s1==s2)    // (strcmp(s1, s2) == 0)

      // time functions
      #define SECONDS_PER_DAY (86400.0)
      #define AddTime(time_t, seconds) (time_t + (seconds / SECONDS_PER_DAY))
      #define DiffTime(time_t1, time_t0) ((time_t1 - time_t0) * SECONDS_PER_DAY)
   #else
      // string functions
      #define strequal(s1, s2) (strcmp(s1, s2) == 0)
   #endif

   #define MULTILINE_25_2   STYLE "MULTILINE 25 2";
   #define MULTILINE_15_20  STYLE "MULTILINE 15 20";
   #define MULTILINE_20_20  STYLE "MULTILINE 20 20";
   #define MULTILINE_27_20  STYLE "MULTILINE 27 20";

   #define REDEFINE_MULTILINE_30_3  REDEFINE STYLE "MULTILINE 30 3";
   #define REDEFINE_MULTILINE_30_4  REDEFINE STYLE "MULTILINE 30 4";
   #define REDEFINE_MULTILINE_30_6  REDEFINE STYLE "MULTILINE 30 6";
   #define REDEFINE_MULTILINE_30_8  REDEFINE STYLE "MULTILINE 30 8";

   /* Menu Styles */
   #define STYLE_ONLINE_WINDOW  STYLE WINDOW; ACCESS ONLINE;
   #define STYLE_ONLINE_DIALOG  STYLE DIALOG; ACCESS ONLINE;
   #define STYLE_OFFLINE_WINDOW STYLE WINDOW; ACCESS OFFLINE;
   #define STYLE_OFFLINE_DIALOG STYLE DIALOG; ACCESS OFFLINE;
   #define STYLE_PAGE           STYLE PAGE;
   #define STYLE_GROUP          STYLE GROUP;
   #define STYLE_TABLE          STYLE TABLE;
   #define STYLE_MENU           STYLE MENU;
   #define MENU_LABEL(label)    label,
#else  // For IFAK and DTM's

   #define MULTILINE_25_2
   #define MULTILINE_15_20
   #define MULTILINE_20_20
   #define MULTILINE_27_20

   #define REDEFINE_MULTILINE_30_3
   #define REDEFINE_MULTILINE_30_4
   #define REDEFINE_MULTILINE_30_6
   #define REDEFINE_MULTILINE_30_8

   #define strequal(s1, s2) (strcmp(s1, s2) == 0)

   /* Menu Styles */
   #define STYLE_ONLINE_WINDOW  STYLE WINDOW;
   #define STYLE_ONLINE_DIALOG  STYLE DIALOG;
   #define STYLE_OFFLINE_WINDOW STYLE WINDOW;
   #define STYLE_OFFLINE_DIALOG STYLE DIALOG;
   #define STYLE_PAGE           STYLE PAGE;
   #define STYLE_GROUP          STYLE GROUP;
   #define STYLE_TABLE          STYLE TABLE;
   #define STYLE_MENU           STYLE MENU;
   #define MENU_LABEL(label)    label,
#endif

/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
