 /*
$Id: hart/HART_Sensor_Level_Milltronics_LR560/echoprocessing.inc 1.6 2010/07/23 05:13:42EDT Thomas Welsh (Thomas Welsh) Dev  $
$ProjectName: d:/elect/source/device_descriptions/pdm/potter_pdm.pj $   $Locker:  $
*/

#ifndef ECHOPROCESSING_DD
#define ECHOPROCESSING_DD
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
       Library File For echo processing tabbed dialog.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

   Defines --------------------------------------------------------------------*/
/* Auto TVT Defines */
#define AUTO_TVT_READ_COMMAND    ReadCommand(read_tvt_setup)
#define AUTO_TVT_WRITE_COMMAND   WriteCommand(write_tvt_setup)
#define AUTO_TVT_RANGE_UNITS_READ_COMMAND ;  // ReadCommand()

#define AUTO_TVT_MODE            par_tb_auto_near_tvt_mode
#define AUTO_TVT_RANGE           par_tb_auto_near_tvt_range

/* Include Files --------------------------------------------------------------*/
#include "readechoprofile.dd"
#include "echoprofileopt.dd"
#include "echoprofile.inc"
#include "saveechoprofile.inc"
#include "tvtShaper120opt.dd"
#include "tvtShaper120.inc"
#include "autotvt.inc"

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
var_backup_tb_algorithm           LIKE VARIABLE par_tb_algorithm           {}
var_backup_tb_echo_position       LIKE VARIABLE par_tb_echo_position       {}
var_backup_tb_conf_thresh_long    LIKE VARIABLE par_tb_conf_thresh_long    {}
var_backup_pb_folf_time_constant  LIKE VARIABLE par_pb_folf_time_constant  {}
var_backup_tb_echo_time_lef_scope LIKE VARIABLE par_tb_echo_time_lef_scope {}
var_backup_tb_response_rate       LIKE VARIABLE par_tb_response_rate       {}
var_backup_tb_fill_rate_limit     LIKE VARIABLE par_tb_fill_rate_limit     {}
var_backup_tb_empty_rate_limit    LIKE VARIABLE par_tb_empty_rate_limit    {}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU OfflineDialog_profile_and_tvt
{
   LABEL  "Echo Profile Utilities|de|Echo Profile Utilities|fr|Utilitaires profil cho|es|Utilidades perfil de eco";
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      Page_echo_profile,
      Page_saved_echo,
      Page_tvt_shaper_graph,
      Page_auto_false_echo_suppression,
      Page_Echo_Setup
   }
}

MENU OfflineDialog_saved_profiles
{
   LABEL  "Echo Profile Utilities|de|Echo Profile Utilities|fr|Utilitaires profil cho|es|Utilidades perfil de eco";
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      Page_saved_echo
   }
}

/*-----------------------------------------------------------------------------
   Description: The Echo Processing Setup tab
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Page_Echo_Setup
{
   LABEL  "Echo Setup|de|Echo Setup|fr|Configuration cho|es|Ajuste eco";
   HELP   "Echo Setup Help|de|Echo Setup Hilfe|fr|Aide  la configuration cho|es|Ayuda ajuste eco";
   STYLE_PAGE
   ITEMS
   {
   COOP_IDENTITY_ON
   Group_Echo_Select,
   Group_echoproc_filtering,
   Group_lef_menu,
   Group_s_rate,
   method_echo_setup_transfer
   }
}

MENU Group_Echo_Select
{
   LABEL  [Tab_s_Echo_Select_label];
   STYLE_GROUP
   ITEMS
   {
      par_tb_algorithm,
      par_tb_echo_position,
      par_tb_conf_thresh_long
   }
}

MENU Group_echoproc_filtering
{
   LABEL [Tab_echoproc_filtering_label];
   STYLE_GROUP
   ITEMS
   {
      par_pb_folf_time_constant
   }
}

MENU Group_lef_menu
{
   LABEL [Tab_lef_menu_label];
   STYLE_GROUP
   ITEMS
   {
      par_tb_echo_time_lef_scope
   }
}

MENU Group_s_rate
{
   LABEL     [Tab_s_rate_label];
   STYLE_GROUP
   ITEMS
   {
      par_tb_response_rate,
      par_tb_fill_rate_limit,
      par_tb_empty_rate_limit
   }
}

/* Visual component Definitions -----------------------------------------------*/

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description    Echo Profile and TVT Tabbed Window
   Created by:    Valerie McQueen
   Revised by:    Gergana Karadjova
 ------------------------------------------------------------------------------*/
METHOD method_menu_profile_and_tvt
{
   LABEL  "Echo Profile Utilities|de|Echo Profile Utilities|fr|Utilitaires profil cho|es|Utilidades perfil de eco";
   HELP   "Echo Profile Utilities Help|de|Echo Profile Utilities Hilfe|fr|Aide pour utilitaires profil cho|es|Ayuda utilidades perfil de eco";
   ACCESS OFFLINE;
   CLASS  INPUT;
   DEFINITION
   {
      long result;
      std_CheckDeviceIdentification();
      if (ret_CheckDeviceIdentification == ID_CHECK_SUCCESS)
         {
         // Make a local copy so we can restore data
         method_backup_tvt_shaper();
         method_backup_auto_near_tvt_shaper();
         method_backup_echo_setup();

         // Add an abort method so we can restore the data
         add_abort_method(method_echoProcessingAbort);

         // Turn on the mode because points may base validity on mode
         TVT_SHAPER_MODE = TVT_SHAPER_MODE_ON;

         MenuDisplay(OfflineDialog_profile_and_tvt, dictionary_string(close_button_label), result);

         /* prevent range warnings when units are changed */
         var_backup_auto_tvt_range = 0.0;
         var_backup_tb_echo_time_lef_scope = 0.0;

         // Remove the abort method that was added earlier
         remove_abort_method(method_echoProcessingAbort);
         }
      else
         {
         MenuDisplay(OfflineDialog_saved_profiles, dictionary_string(close_button_label), result);
         }
   }
}

/*-----------------------------------------------------------------------------
   Description:
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_echoProcessingAbort
{
   DEFINITION
   {
      method_restore_tvt_shaper();
      method_restore_auto_near_tvt_shaper();
      method_restore_echo_setup();
   }
}

/*-----------------------------------------------------------------------------
   Description: Make a backup copy of the data we are modifying so it can be
                restored if needed
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_backup_echo_setup
{
   DEFINITION
   {
      var_backup_tb_algorithm           = par_tb_algorithm;
      var_backup_tb_echo_position       = par_tb_echo_position;
      var_backup_tb_conf_thresh_long    = par_tb_conf_thresh_long;
      var_backup_pb_folf_time_constant  = par_pb_folf_time_constant;
      var_backup_tb_echo_time_lef_scope = par_tb_echo_time_lef_scope;
      var_backup_tb_response_rate       = par_tb_response_rate;
      var_backup_tb_fill_rate_limit     = par_tb_fill_rate_limit;
      var_backup_tb_empty_rate_limit    = par_tb_empty_rate_limit;
   }
}

/*-----------------------------------------------------------------------------
   Description: Restore the data we are modifying from the backup copy
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_restore_echo_setup
{
   DEFINITION
   {
      par_tb_algorithm           = var_backup_tb_algorithm;
      par_tb_echo_position       = var_backup_tb_echo_position;
      par_tb_conf_thresh_long    = var_backup_tb_conf_thresh_long;
      par_pb_folf_time_constant  = var_backup_pb_folf_time_constant;
      par_tb_echo_time_lef_scope = var_backup_tb_echo_time_lef_scope;
      par_tb_response_rate       = var_backup_tb_response_rate;
      par_tb_fill_rate_limit     = var_backup_tb_fill_rate_limit;
      par_tb_empty_rate_limit    = var_backup_tb_empty_rate_limit;

      /* prevent range warnings when units are changed */
      var_backup_tb_echo_time_lef_scope = 0.0;
      
   }
}

/*-----------------------------------------------------------------------------
   Description    Transfer button from echo setup window
   Created by:    Valerie McQueen
   Revised by:    Gergana Karadjova
 ------------------------------------------------------------------------------*/
METHOD method_echo_setup_transfer
{
   LABEL [transfer_to_device_button_label];
   HELP  [transfer_to_device_button_help];
   DEFINITION
   {
      WriteCommand(write_tb_quick_setup1);
      WriteCommand(write_tb_shaping);
      WriteCommand(write_tb_confidence);
      WriteCommand(write_pb_ma_limits);
      WriteCommand(write_tb_rate);
   }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
