 /*
$Id: hart/HART_Sensor_Level_Milltronics_LR560/echoprofile.inc 1.11 2010/06/03 18:11:56EDT Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/pdm/potter_pdm.pj $   $Locker:  $
*/

#ifndef ECHOPROFILE_INC
#define ECHOPROFILE_INC
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
       Library File For echo profile.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------

   Defines --------------------------------------------------------------------*/

/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/

/* Relations (Unit, Array, Refresh) -------------------------------------------*/
UNIT echo_profile_units
{
   par_x_axis_units
   :
   x_axis_echo_profile,
   var_local_window_sill_start,
   var_local_window_sill_end,
   var_local_echo_marker_distance
}

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_local_echo_profile_taken
{
   CLASS LOCAL;
   TYPE  UNSIGNED_INTEGER(1);
   DEFAULT_VALUE ECHO_PROFILE_NOT_TAKEN;
}

/*-----------------------------------------------------------------------------
   Description: Variables to display echo marker
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_local_echo_marker_bottom
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0;
   CONSTANT_UNIT [UNIT_DECIBEL];
}

VARIABLE var_local_echo_marker_top
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0;
   CONSTANT_UNIT [UNIT_DECIBEL];
}

VARIABLE var_local_echo_marker_distance
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0.0;
}

/*-----------------------------------------------------------------------------
   Description: Variables to display window sill
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_local_window_sill_offset
{
   CLASS LOCAL;
   TYPE UNSIGNED_INTEGER;
   DEFAULT_VALUE 0;
}

VARIABLE var_local_window_sill
{
   CLASS LOCAL;
   TYPE UNSIGNED_INTEGER;
   DEFAULT_VALUE 0;
}

VARIABLE var_local_window_sill_start
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0.0;
}

VARIABLE var_local_window_sill_end
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0.0;
}

VARIABLE var_resolution_local
{
    LABEL "Resolution|de|Auflsung|fr|Rsolution|es|Resolucin";
    HELP  "The standard resolution will upload the profile faster but will not show as much details as the detailed view.|de|Die Auflsung 'Standard' ermglicht einen schnelleren Upload des Profils, zeigt aber nicht so viele Details wie die Einstellung 'Hoch'.|fr|La rsolution standard permet un chargement plus rapide du profil mais une visualisation moins prcise que la visualisation Dtaille.|es|La resolucin estndar permite cargar perfiles ms rpidamente, con menos detalles respecto a la visualizacin detallada.";
    CLASS   LOCAL;
    TYPE    ENUMERATED
    {
        {0, "Standard|de|Standard|fr|Standard|es|Estndar"},
        {1, "Detailed|de|Hoch|fr|Dtaille|es|Detallada"}
    }
    DEFAULT_VALUE   0;
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Page_echo_profile
{
   LABEL [OnlineWindow_echo_label];
   HELP  [OnlineWindow_echo_help];
   STYLE_PAGE
   ITEMS
   {
      COOP_IDENTITY_ON
      graph_echo_profile,
      [profile_legend_label],
      COLUMNBREAK,
      Group_echo_values,
      Group_measure_echo_profile
      #ifdef SAVEECHOPROFILE_INC
         ,
         ROWBREAK,
         Group_list_echo_profile,
         COLUMNBREAK,
         Group_time_based_storing
      #endif
   }
}

MENU Group_echo_values
{
   STYLE_GROUP
   ITEMS
   {
      ECHO_PROFILE_PAR_READING         ( READ_ONLY ),
      ECHO_PROFILE_PAR_LEVEL           ( HIDDEN ),
      ECHO_PROFILE_PAR_DISTANCE        ( READ_ONLY ),
      ECHO_PROFILE_PAR_NEAR_BLANKING   ( READ_ONLY ),
      par_tb_conf_long                 ( READ_ONLY ),
      par_tb_echo_strength             ( READ_ONLY ),
      par_tb_algorithm                 ( READ_ONLY )
   }
}

MENU Group_measure_echo_profile
{
   LABEL [group_measure_label];
   STYLE_GROUP
   ITEMS
   {
      ECHO_PROFILE_DEVICE_STATUS,
      var_resolution_local,
      method_measure_echo_profile
   }
}

/* Visual component Definitions -----------------------------------------------*/

/*-----------------------------------------------------------------------------
   Description: Displays graph area, content is referenced from here
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
GRAPH graph_echo_profile
{
   X_AXIS x_axis_echo_profile;
   MEMBERS
      {
      WAVEFORM_ECHO_PROFILE_ECHO,   waveform_echo_profile;
      WAVEFORM_ECHO_PROFILE_TVT,    waveform_tvt;
      WAVEFORM_ECHO_PROFILE_MARKER, waveform_profile_marker;
      WAVEFORM_ECHO_PROFILE_WINDOW, waveform_window_marker;
      }
   WIDTH MEDIUM;
   HEIGHT LARGE;
   VALIDITY IF (var_local_echo_profile_taken == ECHO_PROFILE_TAKEN)
            {
               TRUE;
            }
            ELSE
            {
               FALSE;
            }
}

WAVEFORM waveform_echo_profile
{
   LINE_COLOR ECHO_PROFILE_WAVEFORM_ECHO_PROFILE_COLOR;
   Y_AXIS     y_axis_echo_profile;
   TYPE       YT
      {
      X_INITIAL        par_x_axis_start;
      X_INCREMENT      par_x_axis_sample_increment_spectrum;
      NUMBER_OF_POINTS NUMBER_ECHO_POINTS;
      Y_VALUES
         {
         echo_profile_point
         }
      }
   INIT_ACTIONS
      {
      method_measure_echo_profile
      }
}

WAVEFORM waveform_tvt
{
    LINE_COLOR ECHO_PROFILE_WAVEFORM_TVT_COLOR;
    Y_AXIS     y_axis_echo_profile;
    TYPE       YT
    {
        X_INITIAL        par_x_axis_start;
        X_INCREMENT      par_x_axis_sample_increment_tvt;
        NUMBER_OF_POINTS NUMBER_TVT_POINTS;
        Y_VALUES
        {
            tvt_point
        }
    }
}

/* draw the selected echo marker */
WAVEFORM waveform_profile_marker
{
   EMPHASIS   TRUE;
   LINE_COLOR ECHO_PROFILE_WAVEFORM_PROFILE_MARKER_COLOR;
   Y_AXIS     y_axis_echo_profile;
   TYPE       XY
      {
      X_VALUES
         {
         var_local_echo_marker_distance, var_local_echo_marker_distance
         }
      Y_VALUES
         {
         var_local_echo_marker_top,      var_local_echo_marker_bottom
         }
      NUMBER_OF_POINTS 2;
      }
}

/* draw the window sill marker */
WAVEFORM waveform_window_marker
{
   LINE_COLOR ECHO_PROFILE_WAVEFORM_WINDOW_MARKER_COLOR;
   Y_AXIS     y_axis_echo_profile;
   TYPE       XY
      {
      X_VALUES
         {
         var_local_window_sill_start,  var_local_window_sill_start, var_local_window_sill_end, var_local_window_sill_end
         }
      Y_VALUES
         {
         var_local_window_sill_offset, var_local_window_sill,       var_local_window_sill,     var_local_window_sill_offset
         }
      NUMBER_OF_POINTS 4;
      }
}

AXIS y_axis_echo_profile
{
    LABEL         [profile_label];
    MIN_VALUE     par_db_start_y_axis;
    MAX_VALUE     par_db_end_y_axis;
    CONSTANT_UNIT [UNIT_DECIBEL];
}

AXIS x_axis_echo_profile
{
    LABEL         [Distance_label];
    MIN_VALUE     par_x_axis_start;
    MAX_VALUE     par_x_axis_end;
}

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description    Echo Profile Window
   Created by:    Valerie McQueen
   Revised by:    Gergana Karadjova
 ------------------------------------------------------------------------------*/
METHOD method_measure_echo_profile
{
  LABEL [method_measure_echo_profile_label];
  HELP  [group_measure_help];
  DEFINITION
  {
      if (var_resolution_local == 0)
      {
          method_read_profile_std();
      } else {
          method_read_profile();
      }
 
      // Compute echo marker values
      var_local_echo_marker_bottom            = par_db_start_y_axis;
      var_local_echo_marker_top               = var_local_echo_marker_bottom + par_tb_conf_long;
      var_local_echo_marker_distance          = par_x_axis_reading_value;

      // Compute window sill values
      var_local_window_sill                   = par_window_sill;
      var_local_window_sill_offset            = var_local_window_sill + 2;

      if (par_tb_echo_lock_window != 0)
         {
         var_local_window_sill_start          = par_x_axis_reading_value - (par_tb_echo_lock_window / 2.0);
         var_local_window_sill_end            = par_x_axis_reading_value + (par_tb_echo_lock_window / 2.0);
         }
      else
         {
         
         var_local_window_sill_start          = par_x_axis_reading_value - ((par_x_axis_end - par_x_axis_start) / 40.0);
         var_local_window_sill_end            = par_x_axis_reading_value + ((par_x_axis_end - par_x_axis_start) / 40.0);
         }

      var_local_echo_profile_taken            = var_echo_profile_valid;
      #ifdef SAVEECHOPROFILE_INC
         method_reset_save_profile();
      #endif
  }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
