 /*
$Id: hart/HART_Sensor_Level_Milltronics_LR560/saveechoprofile.inc 1.13 2010/01/11 12:40:17EST Bond, Roland (Roland Bond) Dev  $
$ProjectName: d:/elect/source/device_descriptions/pdm/potter_pdm.pj $   $Locker:  $
*/
#ifndef SAVEECHOPROFILE_INC
#define SAVEECHOPROFILE_INC
#endif

/*                                                       For Internal Use Only.
   Description ----------------------------------------------------------------
       Library File to save echo profiles data and display the profiles.

         Copyright (C) Siemens-Milltronics Process Instruments Inc.
         All Rights Reserved.

   Warnings -------------------------------------------------------------------

   Special Revision Notes -----------------------------------------------------
       Requires the "echoprofile.inc" echo profile module to collect the profiles
       that are used by this module

   Defines --------------------------------------------------------------------*/
#define MAXIMUM_SAVED_PROFILES      60      // var_list_select needs to be updated if this value is changed

#define MACRO_PROFILE_LIST_ELEMENTS( I )               \
         IF ( list_profile.COUNT > I )                 \
            {                                          \
               {  I, list_profile[ I ].PROFILE_NAME }, \
            }                                          \
         ELSE                                          \
            {                                          \
               {I, [Not_saved_label] },                \
            }

#define HAVE_SAVED_PROFILES                   \
            IF (list_profile.COUNT > 0)       \
               {                              \
               TRUE;                          \
               }                              \
            ELSE                              \
               {                              \
               FALSE;                         \
               }
               
#define TIME_BASED_SAVING_WARNING_LABEL                                                                \
      "WARNING: The following process will eventually take a very long time. Please make sure that\n"  \
      "the Parameters 'Interval' and 'Nr. of Profiles to Store' are correctly entered, so that they\n" \
      "fit to your requirements. You will have the possibility to cancel this process during the\n"    \
      "Interval Time. Be aware that the old stored Echo Profiles will be overwritten and lost."        \
      "|de|WARNUNG: Der folgende Prozess kann lange Zeit in\n"                                         \
      "Anspruch nehmen. Bitte prfen Sie die korrekte Eingabe der Parameter 'Zeitabstand' und\n"       \
      "'Anzahl der zu speichernden Profile', so dass sie Ihren Anforderungen gengen. Sie werden\n"    \
      "die Mglichkeit haben, whrend dieser Pausenzeit den Prozess abzubrechen. Bitte beachten\n"     \
      "Sie, dass bereits gespeicherte Echoprofile berschrieben werden und verloren sind."             \
      "|fr|AVERTISSEMENT : Cette procdure peut tre trs longue  effectuer. Veiller  ce \n"         \
      "que les Paramtres 'Intervalle' et 'Nb. de profils  sauvegarder' sont programms\n"            \
      "correctement, suivant les consignes. Cette procdure peut tre annule durant \n"               \
      "le temps d'intervalle. Les valeurs des profils cho existants seront effaces et perdues."      \
      "|es|ADVERTENCIA: Este proceso es muy largo. Por favor compruebe la correcta programacin \n"    \
      "de los parmetros 'Intervalo' y 'Num. de perfiles para almacenar' segn sus requerimientos. \n" \
      "Existe la posibilidad de anular este proceso durante el Tiempo de intervalo. Este proceso\n"    \
      " sustituye y anula los perfiles de eco memorizados."

#define TIME_BASED_SAVING_LIST_NO_EMPTY_LABEL                                                                         \
      "Echo Profiles List is not Empty. Old stored Echo Profiles will be overwritten. Proceed?"                       \
      "|de|Liste der Echoprofile ist nicht leer. Zuvor gespeicherte Echoprofile werden berschrieben. Fortsetzen?"    \
      "|fr|La liste de profils cho n'est pas vide. Les profils cho sauvegards seront effacs. Continuer ?"         \
      "|es|La lista de perfiles de eco no est vaca. Este proceso sustituye y anula los perfiles de eco memorizados.  Continuar ?"

#define TIME_BASED_SAVING_DELAY_LABEL                                                                                                                                                                                              \
      "INTERVAL TIME WARNING: At this point, you have the possibility of canceling the process by clicking on the 'Cancel' Button. The Echo Profiles stored during this process can be seen."                                      \
      "|de|WARNUNG PAUSENZEIT: An dieser Stelle haben Sie die Mglichkeit, den Prozess abzubrechen, indem Sie auf 'Abbrechen' klicken. Die Echoprofile, die whrend dieses Prozesses gespeichert wurden, knnen angesehen werden." \
      "|fr|AVERTISSEMENT INTERVALLE DE TEMPS : Vous avez la possibilit d'annuler la procdure en cliquant sur le bouton 'Cancel/Annuler'. Les profils cho sauvegards durant la procdure peuvent tre visualiss."              \
      "|es|AVISO INTERVALO DE TIEMPO: El usuario tiene la posibilidad de cancelar el proceso haciendo clic en la tecla 'Cancel/Anular'. Pueden visualizarse los perfiles de eco memorizados durante este proceso."

/* Include Files --------------------------------------------------------------*/

/* Collections ----------------------------------------------------------------*/
COLLECTION collection_profile_info
{
   MEMBERS
   {
      PROFILE_NAME,              var_name_profile_saved;
      COMMENT,                   var_comment_profile_saved;
      DATE_STAMP,                var_date_profile_saved;

      ECHO,                      echo_profile_point;
      TVT,                       tvt_point;
      X_AXIS_START,              par_x_axis_start;
      X_AXIS_END,                par_x_axis_end;
      X_AXIS_INC_PROFILE,        par_x_axis_sample_increment_spectrum;
      X_AXIS_INC_TVT,            par_x_axis_sample_increment_tvt;
      X_AXIS_UNITS,              par_x_axis_units;
      Y_AXIS_START,              par_db_start_y_axis;
      Y_AXIS_END,                par_db_end_y_axis;

      X_AXIS_MARKER,             var_local_echo_marker_distance;
      Y_AXIS_MARKER_END,         var_local_echo_marker_bottom;
      Y_AXIS_MARKER_START,       var_local_echo_marker_top;

      X_AXIS_WINDOW_START,       var_local_window_sill_start;
      X_AXIS_WINDOW_END,         var_local_window_sill_end;
      Y_AXIS_WINDOW_SILL_OFFSET, var_local_window_sill_offset;
      Y_AXIS_WINDOW_SILL,        var_local_window_sill;

      READING,                   ECHO_PROFILE_PAR_READING;
      READING_UNIT,              ECHO_PROFILE_PAR_READING_UNIT;
      CONFIDENCE,                par_tb_conf_long;
      ECHO_STRENGTH,             par_tb_echo_strength;
      BLANKING,                  var_tb_range_lo_local;
      ALGORITHM,                 par_tb_algorithm;
      RESOLUTION,                var_resolution_local;
      LEVEL_READING,             ECHO_PROFILE_PAR_LEVEL;
      DISTANCE_READING,          ECHO_PROFILE_PAR_DISTANCE;
      DISTANCE_UNIT,             ECHO_PROFILE_PAR_DISTANCE_UNIT;
   }
}

/* Relations ------------------------------------------------------------------*/
LIST list_profile
{
   TYPE	 collection_profile_info;
}

ARRAY saved_tvt_point
{
   TYPE local_data_point_y;
   NUMBER_OF_ELEMENTS NUMBER_TVT_POINTS;
}

ARRAY saved_echo_profile_point
{
    TYPE local_data_point_y;
    NUMBER_OF_ELEMENTS NUMBER_ECHO_POINTS;

}

/* Variable Definitions -------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
VARIABLE var_profile_saved
{
   CLASS LOCAL;
   TYPE ENUMERATED(1)
   {
      { 1,   "true"  },
      { 0,   "false" }
   }
   DEFAULT_VALUE 0;
}

VARIABLE var_date_profile_saved
{
   LABEL  [date_profile_label];
   HELP   [date_profile_help];
   CLASS  LOCAL;
   TYPE   DATE_AND_TIME;
   VALIDITY HAVE_SAVED_PROFILES
   HANDLING READ;
}

VARIABLE var_comment_profile_saved
{
   LABEL  [comment_profile_label];
   HELP   [comment_profile_help];
   CLASS  LOCAL;
   TYPE   ASCII ( 50 );
   MULTILINE_25_2
   VALIDITY HAVE_SAVED_PROFILES
   PRE_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_comment
   }
   POST_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_comment
   }
}

VARIABLE var_local_comment_profile_saved
{
   LABEL  [comment_profile_label];
   HELP   [comment_profile_help];
   CLASS  LOCAL;
   TYPE   ASCII ( 50 );
   MULTILINE_25_2
   VALIDITY HAVE_SAVED_PROFILES
   PRE_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_comment_local
   }
   POST_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_comment_local
   }
}

VARIABLE var_name_profile_saved
{
   LABEL  [profile_name_label];
   HELP   [profile_name_help];
   CLASS  LOCAL;
   TYPE   ASCII (25);
   VALIDITY HAVE_SAVED_PROFILES
   PRE_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_name
   }
   POST_EDIT_ACTIONS
   {
      method_pre_post_edit_saved_name
   }
}

VARIABLE var_currently_saved_profile_local
{
   LABEL  [profile_name_label];
   HELP   [profile_name_help];
   CLASS  LOCAL;
   TYPE   ASCII (25);
   HANDLING READ;
   PRE_EDIT_ACTIONS
   {
      method_pre_post_edit_local_name
   }
   POST_EDIT_ACTIONS
   {
      method_pre_post_edit_local_name
   }
}

VARIABLE var_index_list
{
   CLASS LOCAL;
   TYPE INDEX list_profile;
}

VARIABLE var_list_select
{
   LABEL  [var_list_select_label];
   HELP   [var_list_select_help];
   CLASS  LOCAL;
   POST_EDIT_ACTIONS
   {
      DEFINITION
      {
         method_draw_graph();
      }
   }
   VALIDITY HAVE_SAVED_PROFILES
   TYPE     ENUMERATED
   {
      MACRO_PROFILE_LIST_ELEMENTS( 0)
      MACRO_PROFILE_LIST_ELEMENTS( 1)
      MACRO_PROFILE_LIST_ELEMENTS( 2)
      MACRO_PROFILE_LIST_ELEMENTS( 3)
      MACRO_PROFILE_LIST_ELEMENTS( 4)
      MACRO_PROFILE_LIST_ELEMENTS( 5)
      MACRO_PROFILE_LIST_ELEMENTS( 6)
      MACRO_PROFILE_LIST_ELEMENTS( 7)
      MACRO_PROFILE_LIST_ELEMENTS( 8)
      MACRO_PROFILE_LIST_ELEMENTS( 9)
      MACRO_PROFILE_LIST_ELEMENTS(10)
      MACRO_PROFILE_LIST_ELEMENTS(11)
      MACRO_PROFILE_LIST_ELEMENTS(12)
      MACRO_PROFILE_LIST_ELEMENTS(13)
      MACRO_PROFILE_LIST_ELEMENTS(14)
      MACRO_PROFILE_LIST_ELEMENTS(15)
      MACRO_PROFILE_LIST_ELEMENTS(16)
      MACRO_PROFILE_LIST_ELEMENTS(17)
      MACRO_PROFILE_LIST_ELEMENTS(18)
      MACRO_PROFILE_LIST_ELEMENTS(19)
      MACRO_PROFILE_LIST_ELEMENTS(20)
      MACRO_PROFILE_LIST_ELEMENTS(21)
      MACRO_PROFILE_LIST_ELEMENTS(22)
      MACRO_PROFILE_LIST_ELEMENTS(23)
      MACRO_PROFILE_LIST_ELEMENTS(24)
      MACRO_PROFILE_LIST_ELEMENTS(25)
      MACRO_PROFILE_LIST_ELEMENTS(26)
      MACRO_PROFILE_LIST_ELEMENTS(27)
      MACRO_PROFILE_LIST_ELEMENTS(28)
      MACRO_PROFILE_LIST_ELEMENTS(29)
      MACRO_PROFILE_LIST_ELEMENTS(30)
      MACRO_PROFILE_LIST_ELEMENTS(31)
      MACRO_PROFILE_LIST_ELEMENTS(32)
      MACRO_PROFILE_LIST_ELEMENTS(33)
      MACRO_PROFILE_LIST_ELEMENTS(34)
      MACRO_PROFILE_LIST_ELEMENTS(35)
      MACRO_PROFILE_LIST_ELEMENTS(36)
      MACRO_PROFILE_LIST_ELEMENTS(37)
      MACRO_PROFILE_LIST_ELEMENTS(38)
      MACRO_PROFILE_LIST_ELEMENTS(39)
      MACRO_PROFILE_LIST_ELEMENTS(40)
      MACRO_PROFILE_LIST_ELEMENTS(41)
      MACRO_PROFILE_LIST_ELEMENTS(42)
      MACRO_PROFILE_LIST_ELEMENTS(43)
      MACRO_PROFILE_LIST_ELEMENTS(44)
      MACRO_PROFILE_LIST_ELEMENTS(45)
      MACRO_PROFILE_LIST_ELEMENTS(46)
      MACRO_PROFILE_LIST_ELEMENTS(47)
      MACRO_PROFILE_LIST_ELEMENTS(48)
      MACRO_PROFILE_LIST_ELEMENTS(49)
      MACRO_PROFILE_LIST_ELEMENTS(50)
      MACRO_PROFILE_LIST_ELEMENTS(51)
      MACRO_PROFILE_LIST_ELEMENTS(52)
      MACRO_PROFILE_LIST_ELEMENTS(53)
      MACRO_PROFILE_LIST_ELEMENTS(54)
      MACRO_PROFILE_LIST_ELEMENTS(55)
      MACRO_PROFILE_LIST_ELEMENTS(56)
      MACRO_PROFILE_LIST_ELEMENTS(57)
      MACRO_PROFILE_LIST_ELEMENTS(58)
      MACRO_PROFILE_LIST_ELEMENTS(59)
   }
}

VARIABLE var_interval
{

    LABEL "Interval|de|Zeitabstand|fr|Intervalle|es|Intervalo";
    HELP  "Enter the desired interval between stored profiles.|de|Eingabe des gewnschten Zeitabstands zwischen gespeicherten Profilen.|fr|Entrer l'intervalle souhait entre profils sauvegards.|es|Indicar el intervalo deseado entre perfiles memorizados.";
    CLASS         LOCAL;
    HANDLING      READ & WRITE;
    CONSTANT_UNIT "mins";
    TYPE       INTEGER(2)
    {
        MIN_VALUE       0;
        MAX_VALUE       60;
    }
    DEFAULT_VALUE   10;
    POST_EDIT_ACTIONS
    {
       post_edit_var_interval
    }
}

VARIABLE var_number_of_profiles
{
    LABEL "Number of Profiles to Store|de|Anzahl der zu speichernden Profile|fr|Nombre de profils  sauvegarder|es|Numero de perfiles memorizados";
    HELP  "Enter the desired number of profiles to be stored.|de|Eingabe der gewnschten Anzahl der zu speichernden Profile.|fr|Entrer le nombre de profils  sauvegarder.|es|Indicar el nmetro de perfiles memorizados.";
    CLASS      LOCAL;
    HANDLING   READ & WRITE;
    TYPE       INTEGER(2)
    {
        MIN_VALUE       1;
        MAX_VALUE       60;
    }
    DEFAULT_VALUE   5;
    POST_EDIT_ACTIONS
    {
       post_edit_var_number_of_profiles
    }
}

var_tb_conf_long_saved               LIKE VARIABLE par_tb_conf_long
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_tb_echo_strength_saved           LIKE VARIABLE par_tb_echo_strength
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_tb_algorithm_saved               LIKE VARIABLE par_tb_algorithm
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_x_axis_units_saved               LIKE VARIABLE par_x_axis_units
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

VARIABLE var_tb_range_lo_saved 
{
   LABEL [ par_tb_range_lo_label ];
   HELP [ par_tb_range_lo_help ];
   CLASS LOCAL;
   TYPE FLOAT
   {
      DISPLAY_FORMAT LINEAL_DISPLAY_FORMAT(var_x_axis_units_saved);
   }
   DEFAULT_VALUE RANGE_LO_DEFAULT;
   HANDLING READ & WRITE;
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

VARIABLE var_x_axis_max_saved
{
   CLASS LOCAL;
   TYPE FLOAT;
   VALIDITY HAVE_SAVED_PROFILES
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

VARIABLE var_x_axis_min_saved
{
   CLASS LOCAL;
   TYPE FLOAT;
   VALIDITY HAVE_SAVED_PROFILES
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

VARIABLE var_x_profile_increment_saved
{
   CLASS LOCAL;
   TYPE FLOAT;
   VALIDITY HAVE_SAVED_PROFILES
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

VARIABLE var_x_tvt_increment_saved
{
   CLASS LOCAL;
   TYPE FLOAT;
   VALIDITY HAVE_SAVED_PROFILES
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
   
}

VARIABLE var_x_axis_marker_saved
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0.0;
   VALIDITY HAVE_SAVED_PROFILES
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

VARIABLE var_x_axis_window_start_saved
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0.0;
   VALIDITY HAVE_SAVED_PROFILES
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

VARIABLE var_x_axis_window_end_saved
{
   CLASS LOCAL;
   TYPE FLOAT;
   DEFAULT_VALUE 0.0;
   VALIDITY HAVE_SAVED_PROFILES
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}


var_y_axis_start_saved               LIKE VARIABLE local_data_point_y
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_y_axis_end_saved                 LIKE VARIABLE local_data_point_y
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_y_axis_marker_end_saved          LIKE VARIABLE local_data_point_y
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_y_axis_marker_start_saved        LIKE VARIABLE local_data_point_y
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_y_axis_window_sill_offset_saved  LIKE VARIABLE local_data_point_y
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_y_axis_window_sill_saved         LIKE VARIABLE local_data_point_y
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_local_date_stamp_saved           LIKE VARIABLE var_date_profile_saved
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_reading_saved                    LIKE VARIABLE ECHO_PROFILE_PAR_READING
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
   REDEFINE CONSTANT_UNIT var_reading_units_saved(var_reading_units_saved);
}

var_reading_units_saved              LIKE VARIABLE ECHO_PROFILE_PAR_READING_UNIT
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_distance_units_saved              LIKE VARIABLE ECHO_PROFILE_PAR_DISTANCE_UNIT
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_resolution_local_saved           LIKE VARIABLE var_resolution_local
{
    REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

var_distance_saved               LIKE VARIABLE ECHO_PROFILE_PAR_DISTANCE
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
   REDEFINE CONSTANT_UNIT var_distance_units_saved(var_distance_units_saved);
}

var_level_saved              LIKE VARIABLE ECHO_PROFILE_PAR_LEVEL
{
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
   REDEFINE CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

var_status_saved                     LIKE VARIABLE ECHO_PROFILE_STATUS
{ 
   REDEFINE VALIDITY HAVE_SAVED_PROFILES
}

/* Command Definitions --------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/

/* Menu Definitions -----------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Menus for Echo Profile Save Functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Group_list_echo_profile
{
   LABEL  [par_currently_saved_profile_local_label];
   STYLE_GROUP
   ITEMS
   {
      var_currently_saved_profile_local,
      ROWBREAK,
      method_save_list,
      ROWBREAK,
      method_delete_list
   }
   VALIDITY IF (var_local_echo_profile_taken == ECHO_PROFILE_TAKEN)
            {
               TRUE;
            }
            ELSE
            {
               FALSE;
            }
}

MENU Group_time_based_storing
{
   LABEL "Echo Profile Time Based Storage|de|Zeitgesteuertes Speichern des Echoprofils|fr|Sauvegarde temporise de profils cho|es|Memorizacin temporizada de perfiles de eco";
   STYLE_GROUP
   ITEMS
   {
      var_interval,
      ROWBREAK,
      var_number_of_profiles,
      ROWBREAK,
      method_save_cyclic_echo
   }
}

/*-----------------------------------------------------------------------------
   Description: Menus for show saved profile functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
MENU Page_saved_echo
{
   LABEL  [menu_saved_echo_label];
   HELP   [menu_saved_echo_help];
   STYLE_PAGE
   ITEMS
   {
      COOP_IDENTITY_ON
      graph_saved_echo,
      Group_profile_graph_data,
      COLUMNBREAK,
      Group_select_profile,
      Group_saved_echo_values
   }
}

MENU Group_profile_graph_data
{
    STYLE_GROUP
    ITEMS
    {
        "Blue: Echo Profile                    Red: TVT Curve"
        "|de|Blau: Echo Profil                    Rot: TVT Kurve"
        "|fr|Bleu: Echo Profile                   Rouge: Courbe TVT"
        "|es|Azul: Profil de Eco                  Rojo: Curva TVT",
    }
    VALIDITY        HAVE_SAVED_PROFILES
}

MENU Group_saved_echo_values
{
   STYLE_GROUP
   ITEMS
   {
      var_reading_saved          (READ_ONLY),
      var_level_saved            (HIDDEN),
      var_distance_saved         (READ_ONLY),
      var_tb_conf_long_saved     (READ_ONLY),
      var_tb_echo_strength_saved (READ_ONLY),
      var_tb_range_lo_saved      (READ_ONLY),
      var_tb_algorithm_saved     (READ_ONLY),
      var_resolution_local_saved (READ_ONLY)
   }
   VALIDITY        HAVE_SAVED_PROFILES
}

MENU Group_select_profile
{
   LABEL  [group_select_profile_label];
   STYLE_GROUP
   ITEMS
   {
      var_list_select,
      method_delete_list_local,
      var_local_comment_profile_saved,
      method_save_comment_local,
      var_local_date_stamp_saved (READ_ONLY)
   }
   VALIDITY        HAVE_SAVED_PROFILES
}

MENU OfflineDialog_edit_profile
{
   LABEL  [save_as_button_label];
   HELP  [save_button_help];
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      var_name_profile_saved,
      var_comment_profile_saved,
      var_date_profile_saved
   }
}

MENU OfflineDialog_rename_profile
{
   LABEL [rename_profile_label];
   STYLE_OFFLINE_DIALOG
   ITEMS
   {
      [rename_profile_help],
      var_name_profile_saved,
      var_comment_profile_saved,
      var_date_profile_saved
   }
}

/* Visual component Definitions -----------------------------------------------*/
GRAPH graph_saved_echo
{
   X_AXIS saved_x_axis;
   MEMBERS
   {
      WAVEFORM_SAVED_ECHO_PROFILE_ECHO,   waveform_saved_echo;
      WAVEFORM_SAVED_ECHO_PROFILE_TVT,    waveform_saved_tvt;
      WAVEFORM_SAVED_ECHO_PROFILE_MARKER, waveform_saved_profile_marker;
      WAVEFORM_SAVED_ECHO_PROFILE_WINDOW, waveform_saved_window_marker;
   }
   WIDTH LARGE;
   HEIGHT X_LARGE;
   VALIDITY HAVE_SAVED_PROFILES
}

WAVEFORM waveform_saved_echo
{
   Y_AXIS saved_y_axis;
   LINE_COLOR ECHO_PROFILE_WAVEFORM_ECHO_PROFILE_COLOR;
   TYPE YT
   {
      X_INITIAL   var_x_axis_min_saved;
      X_INCREMENT var_x_profile_increment_saved;
      Y_VALUES
      {
         saved_echo_profile_point
      }
      NUMBER_OF_POINTS NUMBER_ECHO_POINTS;
   }
   VALIDITY HAVE_SAVED_PROFILES
   INIT_ACTIONS
   {
      DEFINITION
      {
         var_list_select = 0;
         method_draw_graph();
      }
   }
}

WAVEFORM waveform_saved_tvt
{
   Y_AXIS saved_y_axis;
   LINE_COLOR ECHO_PROFILE_WAVEFORM_TVT_COLOR;
   TYPE YT
   {
      X_INITIAL   var_x_axis_min_saved;
      X_INCREMENT var_x_tvt_increment_saved;
      Y_VALUES
      {
          saved_tvt_point
      }
      NUMBER_OF_POINTS NUMBER_TVT_POINTS;
   }
   VALIDITY HAVE_SAVED_PROFILES
}

WAVEFORM waveform_saved_profile_marker
{
   Y_AXIS saved_y_axis;
   LINE_COLOR ECHO_PROFILE_WAVEFORM_PROFILE_MARKER_COLOR;
   TYPE XY
   {
      X_VALUES
      {
         var_x_axis_marker_saved,
         var_x_axis_marker_saved
      }
      Y_VALUES
      {
         var_y_axis_marker_end_saved,
         var_y_axis_marker_start_saved
      }
      NUMBER_OF_POINTS 2;
   }
   VALIDITY HAVE_SAVED_PROFILES
}

WAVEFORM waveform_saved_window_marker
{
   Y_AXIS saved_y_axis;
   LINE_COLOR ECHO_PROFILE_WAVEFORM_WINDOW_MARKER_COLOR;
   TYPE XY
   {
      X_VALUES
      {
            var_x_axis_window_start_saved,
            var_x_axis_window_start_saved,
            var_x_axis_window_end_saved,
            var_x_axis_window_end_saved
      }
      Y_VALUES
      {
            var_y_axis_window_sill_offset_saved,
            var_y_axis_window_sill_saved,
            var_y_axis_window_sill_saved,
            var_y_axis_window_sill_offset_saved
      }
      NUMBER_OF_POINTS 4;
   }
   VALIDITY HAVE_SAVED_PROFILES
}

AXIS saved_y_axis
{
   LABEL  [profile_label];
   MIN_VALUE var_y_axis_start_saved;
   MAX_VALUE var_y_axis_end_saved;
   CONSTANT_UNIT [UNIT_DECIBEL];
}

AXIS saved_x_axis
{
   LABEL  [Distance_label];
   MIN_VALUE var_x_axis_min_saved;
   MAX_VALUE var_x_axis_max_saved;
   CONSTANT_UNIT var_x_axis_units_saved(var_x_axis_units_saved);
}

/* Method Definitions ---------------------------------------------------------*/
/*-----------------------------------------------------------------------------
   Description: Methods for Echo Profile Save Functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_reset_save_profile
{
   DEFINITION
   {
      var_profile_saved = 0;
      var_date_profile_saved = GetCurrentDateAndTime();
      var_currently_saved_profile_local = dictionary_string(Not_saved_label);
   }
}

METHOD method_save_list
{
   LABEL  [save_button_label];
   HELP   [save_button_help];
   DEFINITION
   {
      DD_STRING oldName;
      DD_STRING oldComment;
      long result;
      int count;
      int theIndex;

      if ((!var_profile_saved) && (list_profile.COUNT >= MAXIMUM_SAVED_PROFILES ))
         {
         PUT_MESSAGE(dictionary_string(maximun_number_of_profiles_label));
         return;
         }

      if (!var_profile_saved)    // To save the profile
         {
         var_name_profile_saved = "";
         var_comment_profile_saved = "";

         ListInsert(list_profile, list_profile.COUNT, collection_profile_info);
         }
      else                      // To edit the saved profile
         {
         oldName    = var_name_profile_saved;
         oldComment = var_comment_profile_saved;
         }
      
      if (!var_profile_saved) {
          MenuDisplay(OfflineDialog_edit_profile, dictionary_string(confirm_buttons_label), result);
      } else {
          MenuDisplay(OfflineDialog_rename_profile, dictionary_string(confirm_buttons_label), result);
      }
      // validate the name
      if (result == 0)  // if ok
         {
         // check that there is a name, if not use the date
         var_name_profile_saved = strtrim(var_name_profile_saved);
         if (strlen(var_name_profile_saved) <= 0)
            {
            var_name_profile_saved = var_date_profile_saved;
            }
         else
            {
            var_name_profile_saved = var_name_profile_saved;
            }

         // check that the name is not duplicated
         for (count = 0; count < (list_profile.COUNT - 1); count++)
            {
            if (strequal(list_profile[count].PROFILE_NAME, var_name_profile_saved))
               {
               result = 1;
               PUT_MESSAGE(dictionary_string(duplicate_name_label));
               break;
               }
            }
         }

      if (!var_profile_saved)    // To save the profile
         {
         if (result == 0) // if still ok after name was validated
            {
            var_currently_saved_profile_local                 = var_name_profile_saved;
            list_profile[list_profile.COUNT - 1].PROFILE_NAME = var_name_profile_saved;
            list_profile[list_profile.COUNT - 1].COMMENT      = var_comment_profile_saved;
            var_profile_saved                                 = 1;
            }
         else
            {
            var_currently_saved_profile_local = dictionary_string(Not_saved_label);
            ListDeleteElementAt(list_profile, list_profile.COUNT - 1);
            }
         }
      else                      // To edit the saved profile
         {
         if (result == 0) // if still ok after name was validated
            {
            var_currently_saved_profile_local                 = var_name_profile_saved;
            list_profile[list_profile.COUNT - 1].PROFILE_NAME = var_name_profile_saved;
            list_profile[list_profile.COUNT - 1].COMMENT      = var_comment_profile_saved;
            }
         else
            {
            var_name_profile_saved    = oldName;
            var_comment_profile_saved = oldComment;
            }
         }
      method_draw_graph();
   }
   VALIDITY
      IF ((list_profile.COUNT < MAXIMUM_SAVED_PROFILES) || (var_profile_saved))
         {
         TRUE;
         }
      ELSE
         {
         FALSE;
         }
}

METHOD method_delete_list
{
   LABEL  [delete_button_label];
   HELP   [delete_button_help];
   DEFINITION
   {
      int result;

      if (!var_profile_saved)
         {
         return;
         }

      result = SELECT_FROM_LIST(dictionary_string(Delete_message_label), dictionary_string(confirm_buttons_label));
      if (result)
         {
         return;
         }

      var_currently_saved_profile_local = dictionary_string(Not_saved_label);
      ListDeleteElementAt(list_profile, list_profile.COUNT - 1);
      var_profile_saved = 0;
   }
}

/*-----------------------------------------------------------------------------
   Description: Methods for show saved profile functionality
   Created by:
   Revised by:
 ------------------------------------------------------------------------------*/
METHOD method_draw_graph
{
   DEFINITION
   {
      int point;

      if ((var_list_select < 0) || (list_profile.COUNT <= var_list_select))
         {
         var_list_select = 0;
         }

      var_index_list= var_list_select;

      for (point = 0; point < NUMBER_ECHO_POINTS; point++)
         {
         saved_echo_profile_point[point] = list_profile[var_index_list].ECHO[point];
         }
      for (point = 0; point < NUMBER_TVT_POINTS; point++)
         {
         saved_tvt_point[point] = list_profile[var_index_list].TVT[point];
         }

      var_local_comment_profile_saved     = list_profile[var_index_list].COMMENT;
      var_local_date_stamp_saved          = list_profile[var_index_list].DATE_STAMP;
      var_tb_conf_long_saved              = list_profile[var_index_list].CONFIDENCE;
      var_tb_echo_strength_saved          = list_profile[var_index_list].ECHO_STRENGTH;
      var_tb_algorithm_saved              = list_profile[var_index_list].ALGORITHM;
      var_x_axis_units_saved              = list_profile[var_index_list].X_AXIS_UNITS;
      var_reading_saved                   = list_profile[var_index_list].READING;
      var_distance_saved                  = list_profile[var_index_list].DISTANCE_READING;
      var_level_saved                     = list_profile[var_index_list].LEVEL_READING;
      var_reading_units_saved             = list_profile[var_index_list].READING_UNIT;
      var_distance_units_saved            = list_profile[var_index_list].DISTANCE_UNIT;
      var_tb_range_lo_saved               = list_profile[var_index_list].BLANKING;
      var_resolution_local_saved          = list_profile[var_index_list].RESOLUTION;
      var_x_axis_max_saved                = list_profile[var_index_list].X_AXIS_END;
      var_x_axis_min_saved                = list_profile[var_index_list].X_AXIS_START;
      var_x_profile_increment_saved       = list_profile[var_index_list].X_AXIS_INC_PROFILE;
      var_x_tvt_increment_saved           = list_profile[var_index_list].X_AXIS_INC_TVT;
      var_x_axis_marker_saved             = list_profile[var_index_list].X_AXIS_MARKER;
      var_x_axis_window_start_saved       = list_profile[var_index_list].X_AXIS_WINDOW_START;
      var_x_axis_window_end_saved         = list_profile[var_index_list].X_AXIS_WINDOW_END;
      var_y_axis_start_saved              = list_profile[var_index_list].Y_AXIS_START;
      var_y_axis_end_saved                = list_profile[var_index_list].Y_AXIS_END;
      var_y_axis_marker_end_saved         = list_profile[var_index_list].Y_AXIS_MARKER_END;
      var_y_axis_marker_start_saved       = list_profile[var_index_list].Y_AXIS_MARKER_START;
      var_y_axis_window_sill_offset_saved = list_profile[var_index_list].Y_AXIS_WINDOW_SILL_OFFSET;
      var_y_axis_window_sill_saved        = list_profile[var_index_list].Y_AXIS_WINDOW_SILL;
   }
}

METHOD method_delete_list_local
{
   LABEL  [delete_button_label];
   HELP   [delete_button_help];
   DEFINITION
   {
      int result;

      result = SELECT_FROM_LIST(dictionary_string(Delete_message_label), dictionary_string(confirm_buttons_label));
      if (result)
         {
         return;
         }

      ListDeleteElementAt(list_profile, var_index_list);
      if (list_profile.COUNT > 0)
         {
         var_list_select = 0;
         method_draw_graph();
         }
   }
   VALIDITY HAVE_SAVED_PROFILES
}

METHOD method_save_comment_local
{
   LABEL  [save_button_label];
   HELP   [save_button_help];
   DEFINITION
   {
      int result;

      result = SELECT_FROM_LIST(dictionary_string(Save_comment_message_label), dictionary_string(confirm_buttons_label));
      if (result)
         {
         var_local_comment_profile_saved = list_profile[var_index_list].COMMENT;
         }
      else
         {
         list_profile[var_index_list].COMMENT = var_local_comment_profile_saved;
         }
   }
   VALIDITY HAVE_SAVED_PROFILES
}

METHOD method_pre_post_edit_saved_comment
{
   DEFINITION
   {
      var_comment_profile_saved = strmid(strtrim(var_comment_profile_saved), 0, 50);
   }
}

METHOD method_pre_post_edit_saved_comment_local
{
   DEFINITION
   {
      var_local_comment_profile_saved = strmid(strtrim(var_local_comment_profile_saved), 0, 50);
   }
}

METHOD method_pre_post_edit_saved_name
{
   DEFINITION
   {
      var_name_profile_saved = strmid(strtrim(var_name_profile_saved), 0, 25);
   }
}

METHOD method_pre_post_edit_local_name
{
   DEFINITION
   {
      var_currently_saved_profile_local = strmid(strtrim(var_currently_saved_profile_local), 0, 25);
   }
}

METHOD method_save_cyclic_echo
{
    LABEL  [start_label];
    HELP   [start_help];    
    DEFINITION
    {
        int count;
        int profilesLeft;
        
        ACKNOWLEDGE(TIME_BASED_SAVING_WARNING_LABEL);
        
        /* Deleting List elements if any */
        if (list_profile.COUNT > 0)
        {
            ACKNOWLEDGE(TIME_BASED_SAVING_LIST_NO_EMPTY_LABEL);
            do
            {
                ListDeleteElementAt(list_profile, list_profile.COUNT - 1);
            } while (list_profile.COUNT > 0);
        }
        
        for (count = 0; count < (var_number_of_profiles - 1); count ++)
           {
           // Get Echo Profile and TVT Curve
              method_measure_echo_profile();
              // Name of Profile same as Date
              var_name_profile_saved            = var_date_profile_saved;
              var_currently_saved_profile_local = var_name_profile_saved;
              var_comment_profile_saved         = "";
              var_local_comment_profile_saved   = var_comment_profile_saved;
              ListInsert(list_profile, list_profile.COUNT, collection_profile_info);
              
              profilesLeft = abs(var_number_of_profiles - count - 1);
              
              //SAVE_ARRAY


              if (var_interval == 0) {
                  DELAY(10, TIME_BASED_SAVING_DELAY_LABEL + "\n\nEcho Profiles Left: %{profilesLeft}|de|\n\nbrige Echoprofile: %{profilesLeft}|fr|\n\nProfils cho restants : %{profilesLeft}|es|\n\nPerfiles de eco restantes: %{profilesLeft}");
              } else {
                  DELAY((var_interval * 60), TIME_BASED_SAVING_DELAY_LABEL + "\n\nEcho Profiles Left: %{profilesLeft}|de|\n\nbrige Echoprofile: %{profilesLeft}|fr|\n\nProfils cho restants : %{profilesLeft}|es|\n\nPerfiles de eco restantes: %{profilesLeft}");
              }
           }
        
        // Saving The last Profile
        // Get Echo Profile and TVT Curve
        method_measure_echo_profile();
        // Name of Profile same as Date
        var_name_profile_saved            = var_date_profile_saved;
        var_currently_saved_profile_local = var_name_profile_saved;
        ListInsert(list_profile, list_profile.COUNT, collection_profile_info);
    }
}

METHOD post_edit_var_interval
{
    DEFINITION
    {
        if (var_interval > var_interval.MAX_VALUE)
        {
            var_interval = var_interval.MAX_VALUE;
        }
        if (var_interval < var_interval.MIN_VALUE)
        {
            var_interval = var_interval.MIN_VALUE;
        }
    }
}

METHOD post_edit_var_number_of_profiles
{
    DEFINITION
    {
        if (var_number_of_profiles > var_number_of_profiles.MAX_VALUE)
        {
            var_number_of_profiles = var_number_of_profiles.MAX_VALUE;
        }
        if (var_number_of_profiles < var_number_of_profiles.MIN_VALUE)
        {
            var_number_of_profiles = var_number_of_profiles.MIN_VALUE;
        }
    }
}

/*-----------------------------------------------------------------------------
                                                         For Internal Use Only.
      Copyright (C) Siemens-Milltronics Process Instruments Inc.
      All Rights Reserved.

End of file -------------------------------------------------------------------*/
